/*
 * Interface wrapper code.
 *
 * Generated by SIP 4.16.7
 *
 *     Copyright: (c) 2013 by Total Control Software
 *     License:   wxWindows License
 */

#include "sipAPI_adv.h"

        #include <wx/aboutdlg.h>

        #include <wx/icon.h>


PyDoc_STRVAR(doc_wxAboutDialogInfo_AddArtist, "AddArtist(artist)\n"
    "\n"
    "Adds an artist name to be shown in the program credits.");

extern "C" {static PyObject *meth_wxAboutDialogInfo_AddArtist(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAboutDialogInfo_AddArtist(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxString* artist;
        int artistState = 0;
        wxAboutDialogInfo *sipCpp;

        static const char *sipKwdList[] = {
            sipName_artist,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "BJ1", &sipSelf, sipType_wxAboutDialogInfo, &sipCpp, sipType_wxString,&artist, &artistState))
        {
            PyErr_Clear();

            sipCpp->AddArtist(*artist);
            sipReleaseType(const_cast<wxString *>(artist),sipType_wxString,artistState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_AboutDialogInfo, sipName_AddArtist, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxAboutDialogInfo_AddDeveloper, "AddDeveloper(developer)\n"
    "\n"
    "Adds a developer name to be shown in the program credits.");

extern "C" {static PyObject *meth_wxAboutDialogInfo_AddDeveloper(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAboutDialogInfo_AddDeveloper(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxString* developer;
        int developerState = 0;
        wxAboutDialogInfo *sipCpp;

        static const char *sipKwdList[] = {
            sipName_developer,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "BJ1", &sipSelf, sipType_wxAboutDialogInfo, &sipCpp, sipType_wxString,&developer, &developerState))
        {
            PyErr_Clear();

            sipCpp->AddDeveloper(*developer);
            sipReleaseType(const_cast<wxString *>(developer),sipType_wxString,developerState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_AboutDialogInfo, sipName_AddDeveloper, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxAboutDialogInfo_AddDocWriter, "AddDocWriter(docwriter)\n"
    "\n"
    "Adds a documentation writer name to be shown in the program credits.");

extern "C" {static PyObject *meth_wxAboutDialogInfo_AddDocWriter(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAboutDialogInfo_AddDocWriter(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxString* docwriter;
        int docwriterState = 0;
        wxAboutDialogInfo *sipCpp;

        static const char *sipKwdList[] = {
            sipName_docwriter,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "BJ1", &sipSelf, sipType_wxAboutDialogInfo, &sipCpp, sipType_wxString,&docwriter, &docwriterState))
        {
            PyErr_Clear();

            sipCpp->AddDocWriter(*docwriter);
            sipReleaseType(const_cast<wxString *>(docwriter),sipType_wxString,docwriterState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_AboutDialogInfo, sipName_AddDocWriter, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxAboutDialogInfo_AddTranslator, "AddTranslator(translator)\n"
    "\n"
    "Adds a translator name to be shown in the program credits.");

extern "C" {static PyObject *meth_wxAboutDialogInfo_AddTranslator(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAboutDialogInfo_AddTranslator(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxString* translator;
        int translatorState = 0;
        wxAboutDialogInfo *sipCpp;

        static const char *sipKwdList[] = {
            sipName_translator,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "BJ1", &sipSelf, sipType_wxAboutDialogInfo, &sipCpp, sipType_wxString,&translator, &translatorState))
        {
            PyErr_Clear();

            sipCpp->AddTranslator(*translator);
            sipReleaseType(const_cast<wxString *>(translator),sipType_wxString,translatorState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_AboutDialogInfo, sipName_AddTranslator, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxAboutDialogInfo_GetName, "GetName() -> String\n"
    "\n"
    "Get the name of the program.");

extern "C" {static PyObject *meth_wxAboutDialogInfo_GetName(PyObject *, PyObject *);}
static PyObject *meth_wxAboutDialogInfo_GetName(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const wxAboutDialogInfo *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxAboutDialogInfo, &sipCpp))
        {
            wxString*sipRes;

            PyErr_Clear();

            sipRes = new wxString(sipCpp->GetName());

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromNewType(sipRes,sipType_wxString,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_AboutDialogInfo, sipName_GetName, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxAboutDialogInfo_HasDescription, "HasDescription() -> bool\n"
    "\n"
    "Returns true if a description string has been specified.");

extern "C" {static PyObject *meth_wxAboutDialogInfo_HasDescription(PyObject *, PyObject *);}
static PyObject *meth_wxAboutDialogInfo_HasDescription(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const wxAboutDialogInfo *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxAboutDialogInfo, &sipCpp))
        {
            bool sipRes;

            PyErr_Clear();

            sipRes = sipCpp->HasDescription();

            if (PyErr_Occurred())
                return 0;

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_AboutDialogInfo, sipName_HasDescription, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxAboutDialogInfo_GetDescription, "GetDescription() -> String\n"
    "\n"
    "Get the description string.");

extern "C" {static PyObject *meth_wxAboutDialogInfo_GetDescription(PyObject *, PyObject *);}
static PyObject *meth_wxAboutDialogInfo_GetDescription(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        wxAboutDialogInfo *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxAboutDialogInfo, &sipCpp))
        {
            wxString*sipRes;

            PyErr_Clear();

            sipRes = new wxString(sipCpp->GetDescription());

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromNewType(sipRes,sipType_wxString,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_AboutDialogInfo, sipName_GetDescription, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxAboutDialogInfo_HasCopyright, "HasCopyright() -> bool\n"
    "\n"
    "Returns true if a copyright string has been specified.");

extern "C" {static PyObject *meth_wxAboutDialogInfo_HasCopyright(PyObject *, PyObject *);}
static PyObject *meth_wxAboutDialogInfo_HasCopyright(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const wxAboutDialogInfo *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxAboutDialogInfo, &sipCpp))
        {
            bool sipRes;

            PyErr_Clear();

            sipRes = sipCpp->HasCopyright();

            if (PyErr_Occurred())
                return 0;

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_AboutDialogInfo, sipName_HasCopyright, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxAboutDialogInfo_GetCopyright, "GetCopyright() -> String\n"
    "\n"
    "Get the copyright string.");

extern "C" {static PyObject *meth_wxAboutDialogInfo_GetCopyright(PyObject *, PyObject *);}
static PyObject *meth_wxAboutDialogInfo_GetCopyright(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const wxAboutDialogInfo *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxAboutDialogInfo, &sipCpp))
        {
            wxString*sipRes;

            PyErr_Clear();

            sipRes = new wxString(sipCpp->GetCopyright());

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromNewType(sipRes,sipType_wxString,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_AboutDialogInfo, sipName_GetCopyright, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxAboutDialogInfo_SetArtists, "SetArtists(artists)\n"
    "\n"
    "Sets the list of artists to be shown in the program credits.");

extern "C" {static PyObject *meth_wxAboutDialogInfo_SetArtists(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAboutDialogInfo_SetArtists(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxArrayString* artists;
        int artistsState = 0;
        wxAboutDialogInfo *sipCpp;

        static const char *sipKwdList[] = {
            sipName_artists,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "BJ1", &sipSelf, sipType_wxAboutDialogInfo, &sipCpp, sipType_wxArrayString,&artists, &artistsState))
        {
            PyErr_Clear();

            sipCpp->SetArtists(*artists);
            sipReleaseType(const_cast<wxArrayString *>(artists),sipType_wxArrayString,artistsState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_AboutDialogInfo, sipName_SetArtists, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxAboutDialogInfo_SetCopyright, "SetCopyright(copyright)\n"
    "\n"
    "Set the short string containing the program copyright information.");

extern "C" {static PyObject *meth_wxAboutDialogInfo_SetCopyright(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAboutDialogInfo_SetCopyright(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxString* copyright;
        int copyrightState = 0;
        wxAboutDialogInfo *sipCpp;

        static const char *sipKwdList[] = {
            sipName_copyright,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "BJ1", &sipSelf, sipType_wxAboutDialogInfo, &sipCpp, sipType_wxString,&copyright, &copyrightState))
        {
            PyErr_Clear();

            sipCpp->SetCopyright(*copyright);
            sipReleaseType(const_cast<wxString *>(copyright),sipType_wxString,copyrightState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_AboutDialogInfo, sipName_SetCopyright, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxAboutDialogInfo_SetDescription, "SetDescription(desc)\n"
    "\n"
    "Set brief, but possibly multiline, description of the program.");

extern "C" {static PyObject *meth_wxAboutDialogInfo_SetDescription(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAboutDialogInfo_SetDescription(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxString* desc;
        int descState = 0;
        wxAboutDialogInfo *sipCpp;

        static const char *sipKwdList[] = {
            sipName_desc,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "BJ1", &sipSelf, sipType_wxAboutDialogInfo, &sipCpp, sipType_wxString,&desc, &descState))
        {
            PyErr_Clear();

            sipCpp->SetDescription(*desc);
            sipReleaseType(const_cast<wxString *>(desc),sipType_wxString,descState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_AboutDialogInfo, sipName_SetDescription, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxAboutDialogInfo_SetDevelopers, "SetDevelopers(developers)\n"
    "\n"
    "Set the list of developers of the program.");

extern "C" {static PyObject *meth_wxAboutDialogInfo_SetDevelopers(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAboutDialogInfo_SetDevelopers(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxArrayString* developers;
        int developersState = 0;
        wxAboutDialogInfo *sipCpp;

        static const char *sipKwdList[] = {
            sipName_developers,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "BJ1", &sipSelf, sipType_wxAboutDialogInfo, &sipCpp, sipType_wxArrayString,&developers, &developersState))
        {
            PyErr_Clear();

            sipCpp->SetDevelopers(*developers);
            sipReleaseType(const_cast<wxArrayString *>(developers),sipType_wxArrayString,developersState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_AboutDialogInfo, sipName_SetDevelopers, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxAboutDialogInfo_SetDocWriters, "SetDocWriters(docwriters)\n"
    "\n"
    "Set the list of documentation writers.");

extern "C" {static PyObject *meth_wxAboutDialogInfo_SetDocWriters(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAboutDialogInfo_SetDocWriters(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxArrayString* docwriters;
        int docwritersState = 0;
        wxAboutDialogInfo *sipCpp;

        static const char *sipKwdList[] = {
            sipName_docwriters,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "BJ1", &sipSelf, sipType_wxAboutDialogInfo, &sipCpp, sipType_wxArrayString,&docwriters, &docwritersState))
        {
            PyErr_Clear();

            sipCpp->SetDocWriters(*docwriters);
            sipReleaseType(const_cast<wxArrayString *>(docwriters),sipType_wxArrayString,docwritersState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_AboutDialogInfo, sipName_SetDocWriters, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxAboutDialogInfo_SetIcon, "SetIcon(icon)\n"
    "\n"
    "Set the icon to be shown in the dialog.");

extern "C" {static PyObject *meth_wxAboutDialogInfo_SetIcon(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAboutDialogInfo_SetIcon(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxIcon* icon;
        wxAboutDialogInfo *sipCpp;

        static const char *sipKwdList[] = {
            sipName_icon,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "BJ9", &sipSelf, sipType_wxAboutDialogInfo, &sipCpp, sipType_wxIcon, &icon))
        {
            PyErr_Clear();

            sipCpp->SetIcon(*icon);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_AboutDialogInfo, sipName_SetIcon, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxAboutDialogInfo_SetLicence, "SetLicence(licence)\n"
    "\n"
    "Set the long, multiline string containing the text of the program\n"
    "licence.");

extern "C" {static PyObject *meth_wxAboutDialogInfo_SetLicence(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAboutDialogInfo_SetLicence(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxString* licence;
        int licenceState = 0;
        wxAboutDialogInfo *sipCpp;

        static const char *sipKwdList[] = {
            sipName_licence,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "BJ1", &sipSelf, sipType_wxAboutDialogInfo, &sipCpp, sipType_wxString,&licence, &licenceState))
        {
            PyErr_Clear();

            sipCpp->SetLicence(*licence);
            sipReleaseType(const_cast<wxString *>(licence),sipType_wxString,licenceState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_AboutDialogInfo, sipName_SetLicence, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxAboutDialogInfo_SetLicense, "SetLicense(licence)\n"
    "\n"
    "This is the same as SetLicence().");

extern "C" {static PyObject *meth_wxAboutDialogInfo_SetLicense(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAboutDialogInfo_SetLicense(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxString* licence;
        int licenceState = 0;
        wxAboutDialogInfo *sipCpp;

        static const char *sipKwdList[] = {
            sipName_licence,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "BJ1", &sipSelf, sipType_wxAboutDialogInfo, &sipCpp, sipType_wxString,&licence, &licenceState))
        {
            PyErr_Clear();

            sipCpp->SetLicense(*licence);
            sipReleaseType(const_cast<wxString *>(licence),sipType_wxString,licenceState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_AboutDialogInfo, sipName_SetLicense, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxAboutDialogInfo_SetName, "SetName(name)\n"
    "\n"
    "Set the name of the program.");

extern "C" {static PyObject *meth_wxAboutDialogInfo_SetName(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAboutDialogInfo_SetName(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxString* name;
        int nameState = 0;
        wxAboutDialogInfo *sipCpp;

        static const char *sipKwdList[] = {
            sipName_name,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "BJ1", &sipSelf, sipType_wxAboutDialogInfo, &sipCpp, sipType_wxString,&name, &nameState))
        {
            PyErr_Clear();

            sipCpp->SetName(*name);
            sipReleaseType(const_cast<wxString *>(name),sipType_wxString,nameState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_AboutDialogInfo, sipName_SetName, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxAboutDialogInfo_SetTranslators, "SetTranslators(translators)\n"
    "\n"
    "Set the list of translators.");

extern "C" {static PyObject *meth_wxAboutDialogInfo_SetTranslators(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAboutDialogInfo_SetTranslators(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxArrayString* translators;
        int translatorsState = 0;
        wxAboutDialogInfo *sipCpp;

        static const char *sipKwdList[] = {
            sipName_translators,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "BJ1", &sipSelf, sipType_wxAboutDialogInfo, &sipCpp, sipType_wxArrayString,&translators, &translatorsState))
        {
            PyErr_Clear();

            sipCpp->SetTranslators(*translators);
            sipReleaseType(const_cast<wxArrayString *>(translators),sipType_wxArrayString,translatorsState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_AboutDialogInfo, sipName_SetTranslators, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxAboutDialogInfo_SetVersion, "SetVersion(version, longVersion=\"\")\n"
    "\n"
    "Set the version of the program.");

extern "C" {static PyObject *meth_wxAboutDialogInfo_SetVersion(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAboutDialogInfo_SetVersion(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxString* version;
        int versionState = 0;
        const wxString& longVersiondef = wxString();
        const wxString* longVersion = &longVersiondef;
        int longVersionState = 0;
        wxAboutDialogInfo *sipCpp;

        static const char *sipKwdList[] = {
            sipName_version,
            sipName_longVersion,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "BJ1|J1", &sipSelf, sipType_wxAboutDialogInfo, &sipCpp, sipType_wxString,&version, &versionState, sipType_wxString,&longVersion, &longVersionState))
        {
            PyErr_Clear();

            sipCpp->SetVersion(*version,*longVersion);
            sipReleaseType(const_cast<wxString *>(version),sipType_wxString,versionState);
            sipReleaseType(const_cast<wxString *>(longVersion),sipType_wxString,longVersionState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_AboutDialogInfo, sipName_SetVersion, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxAboutDialogInfo_SetWebSite, "SetWebSite(url, desc=wx.EmptyString)\n"
    "\n"
    "Set the web site for the program and its description (which defaults\n"
    "to url itself if empty).");

extern "C" {static PyObject *meth_wxAboutDialogInfo_SetWebSite(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxAboutDialogInfo_SetWebSite(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxString* url;
        int urlState = 0;
        const wxString& descdef = wxEmptyString;
        const wxString* desc = &descdef;
        int descState = 0;
        wxAboutDialogInfo *sipCpp;

        static const char *sipKwdList[] = {
            sipName_url,
            sipName_desc,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "BJ1|J1", &sipSelf, sipType_wxAboutDialogInfo, &sipCpp, sipType_wxString,&url, &urlState, sipType_wxString,&desc, &descState))
        {
            PyErr_Clear();

            sipCpp->SetWebSite(*url,*desc);
            sipReleaseType(const_cast<wxString *>(url),sipType_wxString,urlState);
            sipReleaseType(const_cast<wxString *>(desc),sipType_wxString,descState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_AboutDialogInfo, sipName_SetWebSite, NULL);

    return NULL;
}


/* Cast a pointer to a type somewhere in its superclass hierarchy. */
extern "C" {static void *cast_wxAboutDialogInfo(void *, const sipTypeDef *);}
static void *cast_wxAboutDialogInfo(void *ptr, const sipTypeDef *targetType)
{
    if (targetType == sipType_wxAboutDialogInfo)
        return ptr;

    return NULL;
}


/* Call the instance's destructor. */
extern "C" {static void release_wxAboutDialogInfo(void *, int);}
static void release_wxAboutDialogInfo(void *sipCppV,int)
{
    delete reinterpret_cast<wxAboutDialogInfo *>(sipCppV);
}


extern "C" {static void assign_wxAboutDialogInfo(void *, SIP_SSIZE_T, const void *);}
static void assign_wxAboutDialogInfo(void *sipDst, SIP_SSIZE_T sipDstIdx, const void *sipSrc)
{
    reinterpret_cast<wxAboutDialogInfo *>(sipDst)[sipDstIdx] = *reinterpret_cast<const wxAboutDialogInfo *>(sipSrc);
}


extern "C" {static void *array_wxAboutDialogInfo(SIP_SSIZE_T);}
static void *array_wxAboutDialogInfo(SIP_SSIZE_T sipNrElem)
{
    return new wxAboutDialogInfo[sipNrElem];
}


extern "C" {static void *copy_wxAboutDialogInfo(const void *, SIP_SSIZE_T);}
static void *copy_wxAboutDialogInfo(const void *sipSrc, SIP_SSIZE_T sipSrcIdx)
{
    return new wxAboutDialogInfo(reinterpret_cast<const wxAboutDialogInfo *>(sipSrc)[sipSrcIdx]);
}


extern "C" {static void dealloc_wxAboutDialogInfo(sipSimpleWrapper *);}
static void dealloc_wxAboutDialogInfo(sipSimpleWrapper *sipSelf)
{
    if (sipIsPyOwned(sipSelf))
    {
        release_wxAboutDialogInfo(sipGetAddress(sipSelf),0);
    }
}


extern "C" {static void *init_type_wxAboutDialogInfo(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_type_wxAboutDialogInfo(sipSimpleWrapper *, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
    wxAboutDialogInfo *sipCpp = 0;

    {
        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, ""))
        {
            PyErr_Clear();

            sipCpp = new wxAboutDialogInfo();

            if (PyErr_Occurred())
            {
                delete sipCpp;
                return NULL;
            }

            return sipCpp;
        }
    }

    {
        const wxAboutDialogInfo* a0;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, "J9", sipType_wxAboutDialogInfo, &a0))
        {
            sipCpp = new wxAboutDialogInfo(*a0);

            return sipCpp;
        }
    }

    return NULL;
}


static PyMethodDef methods_wxAboutDialogInfo[] = {
    {SIP_MLNAME_CAST(sipName_AddArtist), (PyCFunction)meth_wxAboutDialogInfo_AddArtist, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxAboutDialogInfo_AddArtist)},
    {SIP_MLNAME_CAST(sipName_AddDeveloper), (PyCFunction)meth_wxAboutDialogInfo_AddDeveloper, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxAboutDialogInfo_AddDeveloper)},
    {SIP_MLNAME_CAST(sipName_AddDocWriter), (PyCFunction)meth_wxAboutDialogInfo_AddDocWriter, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxAboutDialogInfo_AddDocWriter)},
    {SIP_MLNAME_CAST(sipName_AddTranslator), (PyCFunction)meth_wxAboutDialogInfo_AddTranslator, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxAboutDialogInfo_AddTranslator)},
    {SIP_MLNAME_CAST(sipName_GetCopyright), meth_wxAboutDialogInfo_GetCopyright, METH_VARARGS, SIP_MLDOC_CAST(doc_wxAboutDialogInfo_GetCopyright)},
    {SIP_MLNAME_CAST(sipName_GetDescription), meth_wxAboutDialogInfo_GetDescription, METH_VARARGS, SIP_MLDOC_CAST(doc_wxAboutDialogInfo_GetDescription)},
    {SIP_MLNAME_CAST(sipName_GetName), meth_wxAboutDialogInfo_GetName, METH_VARARGS, SIP_MLDOC_CAST(doc_wxAboutDialogInfo_GetName)},
    {SIP_MLNAME_CAST(sipName_HasCopyright), meth_wxAboutDialogInfo_HasCopyright, METH_VARARGS, SIP_MLDOC_CAST(doc_wxAboutDialogInfo_HasCopyright)},
    {SIP_MLNAME_CAST(sipName_HasDescription), meth_wxAboutDialogInfo_HasDescription, METH_VARARGS, SIP_MLDOC_CAST(doc_wxAboutDialogInfo_HasDescription)},
    {SIP_MLNAME_CAST(sipName_SetArtists), (PyCFunction)meth_wxAboutDialogInfo_SetArtists, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxAboutDialogInfo_SetArtists)},
    {SIP_MLNAME_CAST(sipName_SetCopyright), (PyCFunction)meth_wxAboutDialogInfo_SetCopyright, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxAboutDialogInfo_SetCopyright)},
    {SIP_MLNAME_CAST(sipName_SetDescription), (PyCFunction)meth_wxAboutDialogInfo_SetDescription, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxAboutDialogInfo_SetDescription)},
    {SIP_MLNAME_CAST(sipName_SetDevelopers), (PyCFunction)meth_wxAboutDialogInfo_SetDevelopers, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxAboutDialogInfo_SetDevelopers)},
    {SIP_MLNAME_CAST(sipName_SetDocWriters), (PyCFunction)meth_wxAboutDialogInfo_SetDocWriters, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxAboutDialogInfo_SetDocWriters)},
    {SIP_MLNAME_CAST(sipName_SetIcon), (PyCFunction)meth_wxAboutDialogInfo_SetIcon, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxAboutDialogInfo_SetIcon)},
    {SIP_MLNAME_CAST(sipName_SetLicence), (PyCFunction)meth_wxAboutDialogInfo_SetLicence, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxAboutDialogInfo_SetLicence)},
    {SIP_MLNAME_CAST(sipName_SetLicense), (PyCFunction)meth_wxAboutDialogInfo_SetLicense, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxAboutDialogInfo_SetLicense)},
    {SIP_MLNAME_CAST(sipName_SetName), (PyCFunction)meth_wxAboutDialogInfo_SetName, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxAboutDialogInfo_SetName)},
    {SIP_MLNAME_CAST(sipName_SetTranslators), (PyCFunction)meth_wxAboutDialogInfo_SetTranslators, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxAboutDialogInfo_SetTranslators)},
    {SIP_MLNAME_CAST(sipName_SetVersion), (PyCFunction)meth_wxAboutDialogInfo_SetVersion, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxAboutDialogInfo_SetVersion)},
    {SIP_MLNAME_CAST(sipName_SetWebSite), (PyCFunction)meth_wxAboutDialogInfo_SetWebSite, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxAboutDialogInfo_SetWebSite)}
};

sipVariableDef variables_wxAboutDialogInfo[] = {
    {PropertyVariable, sipName_Name, &methods_wxAboutDialogInfo[6], &methods_wxAboutDialogInfo[17], NULL, NULL},
    {PropertyVariable, sipName_Description, &methods_wxAboutDialogInfo[5], &methods_wxAboutDialogInfo[11], NULL, NULL},
    {PropertyVariable, sipName_Copyright, &methods_wxAboutDialogInfo[4], &methods_wxAboutDialogInfo[10], NULL, NULL},
};

PyDoc_STRVAR(doc_wxAboutDialogInfo, "AboutDialogInfo()\n"
    "\n"
    "wxAboutDialogInfo contains information shown in the standard About\n"
    "dialog displayed by the wxAboutBox() function.");


sipClassTypeDef sipTypeDef__adv_wxAboutDialogInfo = {
    {
        -1,
        0,
        0,
        SIP_TYPE_CLASS,
        sipNameNr_wxAboutDialogInfo,
        {0}
    },
    {
        sipNameNr_AboutDialogInfo,
        {0, 0, 1},
        21, methods_wxAboutDialogInfo,
        0, 0,
        3, variables_wxAboutDialogInfo,
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    },
    doc_wxAboutDialogInfo,
    -1,
    -1,
    0,
    0,
    init_type_wxAboutDialogInfo,
    0,
    0,
#if PY_MAJOR_VERSION >= 3
    0,
    0,
#else
    0,
    0,
    0,
    0,
#endif
    dealloc_wxAboutDialogInfo,
    assign_wxAboutDialogInfo,
    array_wxAboutDialogInfo,
    copy_wxAboutDialogInfo,
    release_wxAboutDialogInfo,
    cast_wxAboutDialogInfo,
    0,
    0,
    0,
    0,
    0,
    0
};
