/*
 * Interface wrapper code.
 *
 * Generated by SIP 4.16.7
 *
 *     Copyright: (c) 2013 by Total Control Software
 *     License:   wxWindows License
 */

#include "sipAPI_core.h"

        #include <wx/fs_arc.h>

        #include <wx/filesys.h>
        #include <wx/filesys.h>
        #include <wx/object.h>
        #include <wx/object.h>


class sipwxArchiveFSHandler : public wxArchiveFSHandler
{
public:
    sipwxArchiveFSHandler();
    virtual ~sipwxArchiveFSHandler();

    /*
     * There is a public method for every protected method visible from
     * this class.
     */
    static wxString sipProtect_GetAnchor(const wxString&);
    static wxString sipProtect_GetLeftLocation(const wxString&);
    static wxString sipProtect_GetProtocol(const wxString&);
    static wxString sipProtect_GetRightLocation(const wxString&);

    /*
     * There is a protected method for every virtual method visible from
     * this class.
     */
protected:
    wxString FindNext();
    wxString FindFirst(const wxString&,int);

public:
    sipSimpleWrapper *sipPySelf;

private:
    sipwxArchiveFSHandler(const sipwxArchiveFSHandler &);
    sipwxArchiveFSHandler &operator = (const sipwxArchiveFSHandler &);

    char sipPyMethods[2];
};

sipwxArchiveFSHandler::sipwxArchiveFSHandler(): wxArchiveFSHandler(), sipPySelf(0)
{
    memset(sipPyMethods, 0, sizeof (sipPyMethods));
}

sipwxArchiveFSHandler::~sipwxArchiveFSHandler()
{
    sipCommonDtor(sipPySelf);
}

wxString sipwxArchiveFSHandler::FindNext()
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,&sipPyMethods[0],sipPySelf,NULL,sipName_FindNext);

    if (!sipMeth)
        return wxArchiveFSHandler::FindNext();

    extern wxString sipVH__core_3(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *);

    return sipVH__core_3(sipGILState, 0, sipPySelf, sipMeth);
}

wxString sipwxArchiveFSHandler::FindFirst(const wxString& wildcard,int flags)
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,&sipPyMethods[1],sipPySelf,NULL,sipName_FindFirst);

    if (!sipMeth)
        return wxArchiveFSHandler::FindFirst(wildcard,flags);

    extern wxString sipVH__core_210(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *, const wxString&,int);

    return sipVH__core_210(sipGILState, 0, sipPySelf, sipMeth, wildcard, flags);
}

wxString sipwxArchiveFSHandler::sipProtect_GetAnchor(const wxString& location)
{
    return wxFileSystemHandler::GetAnchor(location);
}

wxString sipwxArchiveFSHandler::sipProtect_GetLeftLocation(const wxString& location)
{
    return wxFileSystemHandler::GetLeftLocation(location);
}

wxString sipwxArchiveFSHandler::sipProtect_GetProtocol(const wxString& location)
{
    return wxFileSystemHandler::GetProtocol(location);
}

wxString sipwxArchiveFSHandler::sipProtect_GetRightLocation(const wxString& location)
{
    return wxFileSystemHandler::GetRightLocation(location);
}


PyDoc_STRVAR(doc_wxArchiveFSHandler_GetAnchor, "GetAnchor(location) -> String\n"
    "\n"
    "Returns the anchor if present in the location.");

extern "C" {static PyObject *meth_wxArchiveFSHandler_GetAnchor(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxArchiveFSHandler_GetAnchor(PyObject *, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxString* location;
        int locationState = 0;

        static const char *sipKwdList[] = {
            sipName_location,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "J1", sipType_wxString,&location, &locationState))
        {
            wxString*sipRes;

            PyErr_Clear();

            sipRes = new wxString(sipwxArchiveFSHandler::sipProtect_GetAnchor(*location));
            sipReleaseType(const_cast<wxString *>(location),sipType_wxString,locationState);

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromNewType(sipRes,sipType_wxString,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ArchiveFSHandler, sipName_GetAnchor, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxArchiveFSHandler_GetLeftLocation, "GetLeftLocation(location) -> String\n"
    "\n"
    "Returns the left location string extracted from location.");

extern "C" {static PyObject *meth_wxArchiveFSHandler_GetLeftLocation(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxArchiveFSHandler_GetLeftLocation(PyObject *, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxString* location;
        int locationState = 0;

        static const char *sipKwdList[] = {
            sipName_location,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "J1", sipType_wxString,&location, &locationState))
        {
            wxString*sipRes;

            PyErr_Clear();

            sipRes = new wxString(sipwxArchiveFSHandler::sipProtect_GetLeftLocation(*location));
            sipReleaseType(const_cast<wxString *>(location),sipType_wxString,locationState);

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromNewType(sipRes,sipType_wxString,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ArchiveFSHandler, sipName_GetLeftLocation, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxArchiveFSHandler_GetProtocol, "GetProtocol(location) -> String\n"
    "\n"
    "Returns the protocol string extracted from location.");

extern "C" {static PyObject *meth_wxArchiveFSHandler_GetProtocol(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxArchiveFSHandler_GetProtocol(PyObject *, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxString* location;
        int locationState = 0;

        static const char *sipKwdList[] = {
            sipName_location,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "J1", sipType_wxString,&location, &locationState))
        {
            wxString*sipRes;

            PyErr_Clear();

            sipRes = new wxString(sipwxArchiveFSHandler::sipProtect_GetProtocol(*location));
            sipReleaseType(const_cast<wxString *>(location),sipType_wxString,locationState);

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromNewType(sipRes,sipType_wxString,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ArchiveFSHandler, sipName_GetProtocol, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxArchiveFSHandler_GetRightLocation, "GetRightLocation(location) -> String\n"
    "\n"
    "Returns the right location string extracted from location.");

extern "C" {static PyObject *meth_wxArchiveFSHandler_GetRightLocation(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxArchiveFSHandler_GetRightLocation(PyObject *, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxString* location;
        int locationState = 0;

        static const char *sipKwdList[] = {
            sipName_location,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "J1", sipType_wxString,&location, &locationState))
        {
            wxString*sipRes;

            PyErr_Clear();

            sipRes = new wxString(sipwxArchiveFSHandler::sipProtect_GetRightLocation(*location));
            sipReleaseType(const_cast<wxString *>(location),sipType_wxString,locationState);

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromNewType(sipRes,sipType_wxString,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ArchiveFSHandler, sipName_GetRightLocation, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxArchiveFSHandler_Cleanup, "Cleanup()");

extern "C" {static PyObject *meth_wxArchiveFSHandler_Cleanup(PyObject *, PyObject *);}
static PyObject *meth_wxArchiveFSHandler_Cleanup(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        wxArchiveFSHandler *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxArchiveFSHandler, &sipCpp))
        {
            PyErr_Clear();

            sipCpp->Cleanup();

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ArchiveFSHandler, sipName_Cleanup, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_wxArchiveFSHandler_CanOpen(PyObject *, PyObject *);}
static PyObject *meth_wxArchiveFSHandler_CanOpen(PyObject *, PyObject *)
{

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(NULL, sipName_ArchiveFSHandler, sipName_CanOpen, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_wxArchiveFSHandler_OpenFile(PyObject *, PyObject *);}
static PyObject *meth_wxArchiveFSHandler_OpenFile(PyObject *, PyObject *)
{

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(NULL, sipName_ArchiveFSHandler, sipName_OpenFile, NULL);

    return NULL;
}


/* Cast a pointer to a type somewhere in its superclass hierarchy. */
extern "C" {static void *cast_wxArchiveFSHandler(void *, const sipTypeDef *);}
static void *cast_wxArchiveFSHandler(void *ptr, const sipTypeDef *targetType)
{
    void *res;

    if (targetType == sipType_wxArchiveFSHandler)
        return ptr;

    if ((res = ((const sipClassTypeDef *)sipType_wxFileSystemHandler)->ctd_cast((wxFileSystemHandler *)(wxArchiveFSHandler *)ptr,targetType)) != NULL)
        return res;

    return NULL;
}


/* Call the instance's destructor. */
extern "C" {static void release_wxArchiveFSHandler(void *, int);}
static void release_wxArchiveFSHandler(void *sipCppV,int sipState)
{
    if (sipState & SIP_DERIVED_CLASS)
        delete reinterpret_cast<sipwxArchiveFSHandler *>(sipCppV);
    else
        delete reinterpret_cast<wxArchiveFSHandler *>(sipCppV);
}


extern "C" {static void dealloc_wxArchiveFSHandler(sipSimpleWrapper *);}
static void dealloc_wxArchiveFSHandler(sipSimpleWrapper *sipSelf)
{
    if (sipIsDerived(sipSelf))
        reinterpret_cast<sipwxArchiveFSHandler *>(sipGetAddress(sipSelf))->sipPySelf = NULL;

    if (sipIsPyOwned(sipSelf))
    {
        release_wxArchiveFSHandler(sipGetAddress(sipSelf),sipSelf->flags);
    }
}


extern "C" {static void *init_type_wxArchiveFSHandler(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_type_wxArchiveFSHandler(sipSimpleWrapper *sipSelf, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
    sipwxArchiveFSHandler *sipCpp = 0;

    {
        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, ""))
        {
            PyErr_Clear();

            sipCpp = new sipwxArchiveFSHandler();

            if (PyErr_Occurred())
            {
                delete sipCpp;
                return NULL;
            }

            sipCpp->sipPySelf = sipSelf;

            return sipCpp;
        }
    }

    return NULL;
}


/* Define this type's super-types. */
static sipEncodedTypeDef supers_wxArchiveFSHandler[] = {{159, 255, 1}};


static PyMethodDef methods_wxArchiveFSHandler[] = {
    {SIP_MLNAME_CAST(sipName_CanOpen), meth_wxArchiveFSHandler_CanOpen, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_Cleanup), meth_wxArchiveFSHandler_Cleanup, METH_VARARGS, SIP_MLDOC_CAST(doc_wxArchiveFSHandler_Cleanup)},
    {SIP_MLNAME_CAST(sipName_GetAnchor), (PyCFunction)meth_wxArchiveFSHandler_GetAnchor, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxArchiveFSHandler_GetAnchor)},
    {SIP_MLNAME_CAST(sipName_GetLeftLocation), (PyCFunction)meth_wxArchiveFSHandler_GetLeftLocation, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxArchiveFSHandler_GetLeftLocation)},
    {SIP_MLNAME_CAST(sipName_GetProtocol), (PyCFunction)meth_wxArchiveFSHandler_GetProtocol, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxArchiveFSHandler_GetProtocol)},
    {SIP_MLNAME_CAST(sipName_GetRightLocation), (PyCFunction)meth_wxArchiveFSHandler_GetRightLocation, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxArchiveFSHandler_GetRightLocation)},
    {SIP_MLNAME_CAST(sipName_OpenFile), meth_wxArchiveFSHandler_OpenFile, METH_VARARGS, NULL}
};

PyDoc_STRVAR(doc_wxArchiveFSHandler, "ArchiveFSHandler()\n"
    "\n"
    "A file system handler for accessing files inside of archives.");


sipClassTypeDef sipTypeDef__core_wxArchiveFSHandler = {
    {
        -1,
        0,
        0,
        SIP_TYPE_SCC|SIP_TYPE_CLASS,
        sipNameNr_wxArchiveFSHandler,
        {0}
    },
    {
        sipNameNr_ArchiveFSHandler,
        {0, 0, 1},
        7, methods_wxArchiveFSHandler,
        0, 0,
        0, 0,
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    },
    doc_wxArchiveFSHandler,
    -1,
    -1,
    supers_wxArchiveFSHandler,
    0,
    init_type_wxArchiveFSHandler,
    0,
    0,
#if PY_MAJOR_VERSION >= 3
    0,
    0,
#else
    0,
    0,
    0,
    0,
#endif
    dealloc_wxArchiveFSHandler,
    0,
    0,
    0,
    release_wxArchiveFSHandler,
    cast_wxArchiveFSHandler,
    0,
    0,
    0,
    0,
    0,
    0
};
