/*
 * Interface wrapper code.
 *
 * Generated by SIP 4.16.7
 *
 *     Copyright: (c) 2013 by Total Control Software
 *     License:   wxWindows License
 */

#include "sipAPI_core.h"

        #include <wx/cshelp.h>

        #include <wx/window.h>
        #include <wx/object.h>
        #include <wx/object.h>


class sipwxContextHelp : public wxContextHelp
{
public:
    sipwxContextHelp(wxWindow*,bool);
    sipwxContextHelp(const wxContextHelp&);
    ~sipwxContextHelp();

public:
    sipSimpleWrapper *sipPySelf;

private:
    sipwxContextHelp(const sipwxContextHelp &);
    sipwxContextHelp &operator = (const sipwxContextHelp &);
};

sipwxContextHelp::sipwxContextHelp(wxWindow*window,bool doNow): wxContextHelp(window,doNow), sipPySelf(0)
{
}

sipwxContextHelp::sipwxContextHelp(const wxContextHelp& a0): wxContextHelp(a0), sipPySelf(0)
{
}

sipwxContextHelp::~sipwxContextHelp()
{
    sipCommonDtor(sipPySelf);
}


PyDoc_STRVAR(doc_wxContextHelp_BeginContextHelp, "BeginContextHelp(window) -> bool\n"
    "\n"
    "Puts the application into context-sensitive help mode.");

extern "C" {static PyObject *meth_wxContextHelp_BeginContextHelp(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxContextHelp_BeginContextHelp(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        wxWindow* window;
        wxContextHelp *sipCpp;

        static const char *sipKwdList[] = {
            sipName_window,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "BJ8", &sipSelf, sipType_wxContextHelp, &sipCpp, sipType_wxWindow, &window))
        {
            bool sipRes;

            PyErr_Clear();

            sipRes = sipCpp->BeginContextHelp(window);

            if (PyErr_Occurred())
                return 0;

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ContextHelp, sipName_BeginContextHelp, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxContextHelp_EndContextHelp, "EndContextHelp() -> bool\n"
    "\n"
    "Ends context-sensitive help mode.");

extern "C" {static PyObject *meth_wxContextHelp_EndContextHelp(PyObject *, PyObject *);}
static PyObject *meth_wxContextHelp_EndContextHelp(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        wxContextHelp *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxContextHelp, &sipCpp))
        {
            bool sipRes;

            PyErr_Clear();

            sipRes = sipCpp->EndContextHelp();

            if (PyErr_Occurred())
                return 0;

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ContextHelp, sipName_EndContextHelp, NULL);

    return NULL;
}


/* Cast a pointer to a type somewhere in its superclass hierarchy. */
extern "C" {static void *cast_wxContextHelp(void *, const sipTypeDef *);}
static void *cast_wxContextHelp(void *ptr, const sipTypeDef *targetType)
{
    void *res;

    if (targetType == sipType_wxContextHelp)
        return ptr;

    if ((res = ((const sipClassTypeDef *)sipType_wxObject)->ctd_cast((wxObject *)(wxContextHelp *)ptr,targetType)) != NULL)
        return res;

    return NULL;
}


/* Call the instance's destructor. */
extern "C" {static void release_wxContextHelp(void *, int);}
static void release_wxContextHelp(void *sipCppV,int sipState)
{
    if (sipState & SIP_DERIVED_CLASS)
        delete reinterpret_cast<sipwxContextHelp *>(sipCppV);
    else
        delete reinterpret_cast<wxContextHelp *>(sipCppV);
}


extern "C" {static void assign_wxContextHelp(void *, SIP_SSIZE_T, const void *);}
static void assign_wxContextHelp(void *sipDst, SIP_SSIZE_T sipDstIdx, const void *sipSrc)
{
    reinterpret_cast<wxContextHelp *>(sipDst)[sipDstIdx] = *reinterpret_cast<const wxContextHelp *>(sipSrc);
}


extern "C" {static void *array_wxContextHelp(SIP_SSIZE_T);}
static void *array_wxContextHelp(SIP_SSIZE_T sipNrElem)
{
    return new wxContextHelp[sipNrElem];
}


extern "C" {static void *copy_wxContextHelp(const void *, SIP_SSIZE_T);}
static void *copy_wxContextHelp(const void *sipSrc, SIP_SSIZE_T sipSrcIdx)
{
    return new wxContextHelp(reinterpret_cast<const wxContextHelp *>(sipSrc)[sipSrcIdx]);
}


extern "C" {static void dealloc_wxContextHelp(sipSimpleWrapper *);}
static void dealloc_wxContextHelp(sipSimpleWrapper *sipSelf)
{
    if (sipIsDerived(sipSelf))
        reinterpret_cast<sipwxContextHelp *>(sipGetAddress(sipSelf))->sipPySelf = NULL;

    if (sipIsPyOwned(sipSelf))
    {
        release_wxContextHelp(sipGetAddress(sipSelf),sipSelf->flags);
    }
}


extern "C" {static void *init_type_wxContextHelp(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_type_wxContextHelp(sipSimpleWrapper *sipSelf, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
    sipwxContextHelp *sipCpp = 0;

    {
        wxWindow* window = 0;
        bool doNow = 1;

        static const char *sipKwdList[] = {
            sipName_window,
            sipName_doNow,
        };

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, sipKwdList, sipUnused, "|J8b", sipType_wxWindow, &window, &doNow))
        {
            PyErr_Clear();

            sipCpp = new sipwxContextHelp(window,doNow);

            if (PyErr_Occurred())
            {
                delete sipCpp;
                return NULL;
            }

            sipCpp->sipPySelf = sipSelf;

            return sipCpp;
        }
    }

    {
        const wxContextHelp* a0;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, "J9", sipType_wxContextHelp, &a0))
        {
            sipCpp = new sipwxContextHelp(*a0);

            sipCpp->sipPySelf = sipSelf;

            return sipCpp;
        }
    }

    return NULL;
}


/* Define this type's super-types. */
static sipEncodedTypeDef supers_wxContextHelp[] = {{344, 255, 1}};


static PyMethodDef methods_wxContextHelp[] = {
    {SIP_MLNAME_CAST(sipName_BeginContextHelp), (PyCFunction)meth_wxContextHelp_BeginContextHelp, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxContextHelp_BeginContextHelp)},
    {SIP_MLNAME_CAST(sipName_EndContextHelp), meth_wxContextHelp_EndContextHelp, METH_VARARGS, SIP_MLDOC_CAST(doc_wxContextHelp_EndContextHelp)}
};

PyDoc_STRVAR(doc_wxContextHelp, "ContextHelp(window=None, doNow=True)\n"
    "\n"
    "This class changes the cursor to a query and puts the application into\n"
    "a 'context-sensitive help mode'.");


sipClassTypeDef sipTypeDef__core_wxContextHelp = {
    {
        -1,
        0,
        0,
        SIP_TYPE_SCC|SIP_TYPE_CLASS,
        sipNameNr_wxContextHelp,
        {0}
    },
    {
        sipNameNr_ContextHelp,
        {0, 0, 1},
        2, methods_wxContextHelp,
        0, 0,
        0, 0,
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    },
    doc_wxContextHelp,
    -1,
    -1,
    supers_wxContextHelp,
    0,
    init_type_wxContextHelp,
    0,
    0,
#if PY_MAJOR_VERSION >= 3
    0,
    0,
#else
    0,
    0,
    0,
    0,
#endif
    dealloc_wxContextHelp,
    assign_wxContextHelp,
    array_wxContextHelp,
    copy_wxContextHelp,
    release_wxContextHelp,
    cast_wxContextHelp,
    0,
    0,
    0,
    0,
    0,
    0
};
