/*
 * Interface wrapper code.
 *
 * Generated by SIP 4.16.7
 *
 *     Copyright: (c) 2013 by Total Control Software
 *     License:   wxWindows License
 */

#include "sipAPI_core.h"

        #include <wx/dragimag.h>

        #include <wx/bitmap.h>
        #include <wx/cursor.h>
        #include <wx/icon.h>
        #include <wx/treectrl.h>
        #include <wx/treebase.h>
        #include <wx/listctrl.h>
        #include <wx/gdicmn.h>
        #include <wx/window.h>
        #include <wx/gdicmn.h>
        #include <wx/object.h>
        #include <wx/object.h>


PyDoc_STRVAR(doc_wxDragImage_BeginDrag, "BeginDrag(hotspot, window, fullScreen=False, rect=None) -> bool\n"
    "BeginDrag(hotspot, window, boundingWindow) -> bool\n"
    "\n"
    "Start dragging the image, in a window or full screen.");

extern "C" {static PyObject *meth_wxDragImage_BeginDrag(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxDragImage_BeginDrag(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxPoint* hotspot;
        int hotspotState = 0;
        wxWindow* window;
        bool fullScreen = 0;
        wxRect* rect = 0;
        int rectState = 0;
        wxDragImage *sipCpp;

        static const char *sipKwdList[] = {
            sipName_hotspot,
            sipName_window,
            sipName_fullScreen,
            sipName_rect,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "BJ1J8|bJ0", &sipSelf, sipType_wxDragImage, &sipCpp, sipType_wxPoint, &hotspot, &hotspotState, sipType_wxWindow, &window, &fullScreen, sipType_wxRect, &rect, &rectState))
        {
            bool sipRes;

            PyErr_Clear();

            sipRes = sipCpp->BeginDrag(*hotspot,window,fullScreen,rect);
            sipReleaseType(const_cast<wxPoint *>(hotspot),sipType_wxPoint,hotspotState);
            sipReleaseType(rect,sipType_wxRect,rectState);

            if (PyErr_Occurred())
                return 0;

            return PyBool_FromLong(sipRes);
        }
    }

    {
        const wxPoint* hotspot;
        int hotspotState = 0;
        wxWindow* window;
        wxWindow* boundingWindow;
        wxDragImage *sipCpp;

        static const char *sipKwdList[] = {
            sipName_hotspot,
            sipName_window,
            sipName_boundingWindow,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "BJ1J8J8", &sipSelf, sipType_wxDragImage, &sipCpp, sipType_wxPoint, &hotspot, &hotspotState, sipType_wxWindow, &window, sipType_wxWindow, &boundingWindow))
        {
            bool sipRes;

            PyErr_Clear();

            sipRes = sipCpp->BeginDrag(*hotspot,window,boundingWindow);
            sipReleaseType(const_cast<wxPoint *>(hotspot),sipType_wxPoint,hotspotState);

            if (PyErr_Occurred())
                return 0;

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DragImage, sipName_BeginDrag, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxDragImage_EndDrag, "EndDrag() -> bool\n"
    "\n"
    "Call this when the drag has finished.");

extern "C" {static PyObject *meth_wxDragImage_EndDrag(PyObject *, PyObject *);}
static PyObject *meth_wxDragImage_EndDrag(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        wxDragImage *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxDragImage, &sipCpp))
        {
            bool sipRes;

            PyErr_Clear();

            sipRes = sipCpp->EndDrag();

            if (PyErr_Occurred())
                return 0;

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DragImage, sipName_EndDrag, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxDragImage_Hide, "Hide() -> bool\n"
    "\n"
    "Hides the image.");

extern "C" {static PyObject *meth_wxDragImage_Hide(PyObject *, PyObject *);}
static PyObject *meth_wxDragImage_Hide(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        wxDragImage *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxDragImage, &sipCpp))
        {
            bool sipRes;

            PyErr_Clear();

            sipRes = sipCpp->Hide();

            if (PyErr_Occurred())
                return 0;

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DragImage, sipName_Hide, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxDragImage_Move, "Move(pt) -> bool\n"
    "\n"
    "Call this to move the image to a new position.");

extern "C" {static PyObject *meth_wxDragImage_Move(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxDragImage_Move(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxPoint* pt;
        int ptState = 0;
        wxDragImage *sipCpp;

        static const char *sipKwdList[] = {
            sipName_pt,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "BJ1", &sipSelf, sipType_wxDragImage, &sipCpp, sipType_wxPoint, &pt, &ptState))
        {
            bool sipRes;

            PyErr_Clear();

            sipRes = sipCpp->Move(*pt);
            sipReleaseType(const_cast<wxPoint *>(pt),sipType_wxPoint,ptState);

            if (PyErr_Occurred())
                return 0;

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DragImage, sipName_Move, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxDragImage_Show, "Show() -> bool\n"
    "\n"
    "Shows the image.");

extern "C" {static PyObject *meth_wxDragImage_Show(PyObject *, PyObject *);}
static PyObject *meth_wxDragImage_Show(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        wxDragImage *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxDragImage, &sipCpp))
        {
            bool sipRes;

            PyErr_Clear();

            sipRes = sipCpp->Show();

            if (PyErr_Occurred())
                return 0;

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_DragImage, sipName_Show, NULL);

    return NULL;
}


/* Cast a pointer to a type somewhere in its superclass hierarchy. */
extern "C" {static void *cast_wxDragImage(void *, const sipTypeDef *);}
static void *cast_wxDragImage(void *ptr, const sipTypeDef *targetType)
{
    void *res;

    if (targetType == sipType_wxDragImage)
        return ptr;

    if ((res = ((const sipClassTypeDef *)sipType_wxObject)->ctd_cast((wxObject *)(wxDragImage *)ptr,targetType)) != NULL)
        return res;

    return NULL;
}


/* Call the instance's destructor. */
extern "C" {static void release_wxDragImage(void *, int);}
static void release_wxDragImage(void *sipCppV,int)
{
    delete reinterpret_cast<wxDragImage *>(sipCppV);
}


extern "C" {static void dealloc_wxDragImage(sipSimpleWrapper *);}
static void dealloc_wxDragImage(sipSimpleWrapper *sipSelf)
{
    if (sipIsPyOwned(sipSelf))
    {
        release_wxDragImage(sipGetAddress(sipSelf),0);
    }
}


extern "C" {static void *init_type_wxDragImage(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_type_wxDragImage(sipSimpleWrapper *, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
    wxDragImage *sipCpp = 0;

    {
        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, ""))
        {
            PyErr_Clear();

            sipCpp = new wxDragImage();

            if (PyErr_Occurred())
            {
                delete sipCpp;
                return NULL;
            }

            return sipCpp;
        }
    }

    {
        const wxBitmap* image;
        const wxCursor& cursordef = wxNullCursor;
        const wxCursor* cursor = &cursordef;

        static const char *sipKwdList[] = {
            sipName_image,
            sipName_cursor,
        };

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, sipKwdList, sipUnused, "J9|J9", sipType_wxBitmap, &image, sipType_wxCursor, &cursor))
        {
            PyErr_Clear();

            sipCpp = new wxDragImage(*image,*cursor);

            if (PyErr_Occurred())
            {
                delete sipCpp;
                return NULL;
            }

            return sipCpp;
        }
    }

    {
        const wxIcon* image;
        const wxCursor& cursordef = wxNullCursor;
        const wxCursor* cursor = &cursordef;

        static const char *sipKwdList[] = {
            sipName_image,
            sipName_cursor,
        };

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, sipKwdList, sipUnused, "J9|J9", sipType_wxIcon, &image, sipType_wxCursor, &cursor))
        {
            PyErr_Clear();

            sipCpp = new wxDragImage(*image,*cursor);

            if (PyErr_Occurred())
            {
                delete sipCpp;
                return NULL;
            }

            return sipCpp;
        }
    }

    {
        const wxString* text;
        int textState = 0;
        const wxCursor& cursordef = wxNullCursor;
        const wxCursor* cursor = &cursordef;

        static const char *sipKwdList[] = {
            sipName_text,
            sipName_cursor,
        };

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, sipKwdList, sipUnused, "J1|J9", sipType_wxString,&text, &textState, sipType_wxCursor, &cursor))
        {
            PyErr_Clear();

            sipCpp = new wxDragImage(*text,*cursor);
            sipReleaseType(const_cast<wxString *>(text),sipType_wxString,textState);

            if (PyErr_Occurred())
            {
                delete sipCpp;
                return NULL;
            }

            return sipCpp;
        }
    }

    {
        const wxTreeCtrl* treeCtrl;
        wxTreeItemId* id;

        static const char *sipKwdList[] = {
            sipName_treeCtrl,
            sipName_id,
        };

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, sipKwdList, sipUnused, "J9J9", sipType_wxTreeCtrl, &treeCtrl, sipType_wxTreeItemId, &id))
        {
            PyErr_Clear();

            sipCpp = new wxDragImage(*treeCtrl,*id);

            if (PyErr_Occurred())
            {
                delete sipCpp;
                return NULL;
            }

            return sipCpp;
        }
    }

    {
        const wxListCtrl* listCtrl;
        long id;

        static const char *sipKwdList[] = {
            sipName_listCtrl,
            sipName_id,
        };

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, sipKwdList, sipUnused, "J9l", sipType_wxListCtrl, &listCtrl, &id))
        {
            PyErr_Clear();

            sipCpp = new wxDragImage(*listCtrl,id);

            if (PyErr_Occurred())
            {
                delete sipCpp;
                return NULL;
            }

            return sipCpp;
        }
    }

    return NULL;
}


/* Define this type's super-types. */
static sipEncodedTypeDef supers_wxDragImage[] = {{344, 255, 1}};


static PyMethodDef methods_wxDragImage[] = {
    {SIP_MLNAME_CAST(sipName_BeginDrag), (PyCFunction)meth_wxDragImage_BeginDrag, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxDragImage_BeginDrag)},
    {SIP_MLNAME_CAST(sipName_EndDrag), meth_wxDragImage_EndDrag, METH_VARARGS, SIP_MLDOC_CAST(doc_wxDragImage_EndDrag)},
    {SIP_MLNAME_CAST(sipName_Hide), meth_wxDragImage_Hide, METH_VARARGS, SIP_MLDOC_CAST(doc_wxDragImage_Hide)},
    {SIP_MLNAME_CAST(sipName_Move), (PyCFunction)meth_wxDragImage_Move, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxDragImage_Move)},
    {SIP_MLNAME_CAST(sipName_Show), meth_wxDragImage_Show, METH_VARARGS, SIP_MLDOC_CAST(doc_wxDragImage_Show)}
};

PyDoc_STRVAR(doc_wxDragImage, "DragImage()\n"
    "DragImage(image, cursor=NullCursor)\n"
    "DragImage(image, cursor=NullCursor)\n"
    "DragImage(text, cursor=NullCursor)\n"
    "DragImage(treeCtrl, id)\n"
    "DragImage(listCtrl, id)\n"
    "\n"
    "This class is used when you wish to drag an object on the screen, and\n"
    "a simple cursor is not enough.");


sipClassTypeDef sipTypeDef__core_wxDragImage = {
    {
        -1,
        0,
        0,
        SIP_TYPE_SCC|SIP_TYPE_CLASS,
        sipNameNr_wxDragImage,
        {0}
    },
    {
        sipNameNr_DragImage,
        {0, 0, 1},
        5, methods_wxDragImage,
        0, 0,
        0, 0,
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    },
    doc_wxDragImage,
    -1,
    -1,
    supers_wxDragImage,
    0,
    init_type_wxDragImage,
    0,
    0,
#if PY_MAJOR_VERSION >= 3
    0,
    0,
#else
    0,
    0,
    0,
    0,
#endif
    dealloc_wxDragImage,
    0,
    0,
    0,
    release_wxDragImage,
    cast_wxDragImage,
    0,
    0,
    0,
    0,
    0,
    0
};
