/*
 * Interface wrapper code.
 *
 * Generated by SIP 4.16.7
 *
 *     Copyright: (c) 2013 by Total Control Software
 *     License:   wxWindows License
 */

#include "sipAPI_core.h"

        #include <wx/fs_filter.h>

        #include <wx/filesys.h>
        #include <wx/filesys.h>
        #include <wx/object.h>
        #include <wx/object.h>


class sipwxFilterFSHandler : public wxFilterFSHandler
{
public:
    sipwxFilterFSHandler();
    virtual ~sipwxFilterFSHandler();

    /*
     * There is a public method for every protected method visible from
     * this class.
     */
    static wxString sipProtect_GetAnchor(const wxString&);
    static wxString sipProtect_GetLeftLocation(const wxString&);
    static wxString sipProtect_GetProtocol(const wxString&);
    static wxString sipProtect_GetRightLocation(const wxString&);

    /*
     * There is a protected method for every virtual method visible from
     * this class.
     */
protected:
    wxString FindNext();
    wxString FindFirst(const wxString&,int);

public:
    sipSimpleWrapper *sipPySelf;

private:
    sipwxFilterFSHandler(const sipwxFilterFSHandler &);
    sipwxFilterFSHandler &operator = (const sipwxFilterFSHandler &);

    char sipPyMethods[2];
};

sipwxFilterFSHandler::sipwxFilterFSHandler(): wxFilterFSHandler(), sipPySelf(0)
{
    memset(sipPyMethods, 0, sizeof (sipPyMethods));
}

sipwxFilterFSHandler::~sipwxFilterFSHandler()
{
    sipCommonDtor(sipPySelf);
}

wxString sipwxFilterFSHandler::FindNext()
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,&sipPyMethods[0],sipPySelf,NULL,sipName_FindNext);

    if (!sipMeth)
        return wxFilterFSHandler::FindNext();

    extern wxString sipVH__core_3(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *);

    return sipVH__core_3(sipGILState, 0, sipPySelf, sipMeth);
}

wxString sipwxFilterFSHandler::FindFirst(const wxString& wildcard,int flags)
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,&sipPyMethods[1],sipPySelf,NULL,sipName_FindFirst);

    if (!sipMeth)
        return wxFilterFSHandler::FindFirst(wildcard,flags);

    extern wxString sipVH__core_210(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *, const wxString&,int);

    return sipVH__core_210(sipGILState, 0, sipPySelf, sipMeth, wildcard, flags);
}

wxString sipwxFilterFSHandler::sipProtect_GetAnchor(const wxString& location)
{
    return wxFileSystemHandler::GetAnchor(location);
}

wxString sipwxFilterFSHandler::sipProtect_GetLeftLocation(const wxString& location)
{
    return wxFileSystemHandler::GetLeftLocation(location);
}

wxString sipwxFilterFSHandler::sipProtect_GetProtocol(const wxString& location)
{
    return wxFileSystemHandler::GetProtocol(location);
}

wxString sipwxFilterFSHandler::sipProtect_GetRightLocation(const wxString& location)
{
    return wxFileSystemHandler::GetRightLocation(location);
}


PyDoc_STRVAR(doc_wxFilterFSHandler_GetAnchor, "GetAnchor(location) -> String\n"
    "\n"
    "Returns the anchor if present in the location.");

extern "C" {static PyObject *meth_wxFilterFSHandler_GetAnchor(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxFilterFSHandler_GetAnchor(PyObject *, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxString* location;
        int locationState = 0;

        static const char *sipKwdList[] = {
            sipName_location,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "J1", sipType_wxString,&location, &locationState))
        {
            wxString*sipRes;

            PyErr_Clear();

            sipRes = new wxString(sipwxFilterFSHandler::sipProtect_GetAnchor(*location));
            sipReleaseType(const_cast<wxString *>(location),sipType_wxString,locationState);

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromNewType(sipRes,sipType_wxString,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_FilterFSHandler, sipName_GetAnchor, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxFilterFSHandler_GetLeftLocation, "GetLeftLocation(location) -> String\n"
    "\n"
    "Returns the left location string extracted from location.");

extern "C" {static PyObject *meth_wxFilterFSHandler_GetLeftLocation(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxFilterFSHandler_GetLeftLocation(PyObject *, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxString* location;
        int locationState = 0;

        static const char *sipKwdList[] = {
            sipName_location,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "J1", sipType_wxString,&location, &locationState))
        {
            wxString*sipRes;

            PyErr_Clear();

            sipRes = new wxString(sipwxFilterFSHandler::sipProtect_GetLeftLocation(*location));
            sipReleaseType(const_cast<wxString *>(location),sipType_wxString,locationState);

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromNewType(sipRes,sipType_wxString,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_FilterFSHandler, sipName_GetLeftLocation, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxFilterFSHandler_GetProtocol, "GetProtocol(location) -> String\n"
    "\n"
    "Returns the protocol string extracted from location.");

extern "C" {static PyObject *meth_wxFilterFSHandler_GetProtocol(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxFilterFSHandler_GetProtocol(PyObject *, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxString* location;
        int locationState = 0;

        static const char *sipKwdList[] = {
            sipName_location,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "J1", sipType_wxString,&location, &locationState))
        {
            wxString*sipRes;

            PyErr_Clear();

            sipRes = new wxString(sipwxFilterFSHandler::sipProtect_GetProtocol(*location));
            sipReleaseType(const_cast<wxString *>(location),sipType_wxString,locationState);

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromNewType(sipRes,sipType_wxString,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_FilterFSHandler, sipName_GetProtocol, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxFilterFSHandler_GetRightLocation, "GetRightLocation(location) -> String\n"
    "\n"
    "Returns the right location string extracted from location.");

extern "C" {static PyObject *meth_wxFilterFSHandler_GetRightLocation(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxFilterFSHandler_GetRightLocation(PyObject *, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxString* location;
        int locationState = 0;

        static const char *sipKwdList[] = {
            sipName_location,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "J1", sipType_wxString,&location, &locationState))
        {
            wxString*sipRes;

            PyErr_Clear();

            sipRes = new wxString(sipwxFilterFSHandler::sipProtect_GetRightLocation(*location));
            sipReleaseType(const_cast<wxString *>(location),sipType_wxString,locationState);

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromNewType(sipRes,sipType_wxString,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_FilterFSHandler, sipName_GetRightLocation, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_wxFilterFSHandler_CanOpen(PyObject *, PyObject *);}
static PyObject *meth_wxFilterFSHandler_CanOpen(PyObject *, PyObject *)
{

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(NULL, sipName_FilterFSHandler, sipName_CanOpen, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_wxFilterFSHandler_OpenFile(PyObject *, PyObject *);}
static PyObject *meth_wxFilterFSHandler_OpenFile(PyObject *, PyObject *)
{

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(NULL, sipName_FilterFSHandler, sipName_OpenFile, NULL);

    return NULL;
}


/* Cast a pointer to a type somewhere in its superclass hierarchy. */
extern "C" {static void *cast_wxFilterFSHandler(void *, const sipTypeDef *);}
static void *cast_wxFilterFSHandler(void *ptr, const sipTypeDef *targetType)
{
    void *res;

    if (targetType == sipType_wxFilterFSHandler)
        return ptr;

    if ((res = ((const sipClassTypeDef *)sipType_wxFileSystemHandler)->ctd_cast((wxFileSystemHandler *)(wxFilterFSHandler *)ptr,targetType)) != NULL)
        return res;

    return NULL;
}


/* Call the instance's destructor. */
extern "C" {static void release_wxFilterFSHandler(void *, int);}
static void release_wxFilterFSHandler(void *sipCppV,int sipState)
{
    if (sipState & SIP_DERIVED_CLASS)
        delete reinterpret_cast<sipwxFilterFSHandler *>(sipCppV);
    else
        delete reinterpret_cast<wxFilterFSHandler *>(sipCppV);
}


extern "C" {static void dealloc_wxFilterFSHandler(sipSimpleWrapper *);}
static void dealloc_wxFilterFSHandler(sipSimpleWrapper *sipSelf)
{
    if (sipIsDerived(sipSelf))
        reinterpret_cast<sipwxFilterFSHandler *>(sipGetAddress(sipSelf))->sipPySelf = NULL;

    if (sipIsPyOwned(sipSelf))
    {
        release_wxFilterFSHandler(sipGetAddress(sipSelf),sipSelf->flags);
    }
}


extern "C" {static void *init_type_wxFilterFSHandler(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_type_wxFilterFSHandler(sipSimpleWrapper *sipSelf, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
    sipwxFilterFSHandler *sipCpp = 0;

    {
        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, ""))
        {
            PyErr_Clear();

            sipCpp = new sipwxFilterFSHandler();

            if (PyErr_Occurred())
            {
                delete sipCpp;
                return NULL;
            }

            sipCpp->sipPySelf = sipSelf;

            return sipCpp;
        }
    }

    return NULL;
}


/* Define this type's super-types. */
static sipEncodedTypeDef supers_wxFilterFSHandler[] = {{159, 255, 1}};


static PyMethodDef methods_wxFilterFSHandler[] = {
    {SIP_MLNAME_CAST(sipName_CanOpen), meth_wxFilterFSHandler_CanOpen, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_GetAnchor), (PyCFunction)meth_wxFilterFSHandler_GetAnchor, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxFilterFSHandler_GetAnchor)},
    {SIP_MLNAME_CAST(sipName_GetLeftLocation), (PyCFunction)meth_wxFilterFSHandler_GetLeftLocation, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxFilterFSHandler_GetLeftLocation)},
    {SIP_MLNAME_CAST(sipName_GetProtocol), (PyCFunction)meth_wxFilterFSHandler_GetProtocol, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxFilterFSHandler_GetProtocol)},
    {SIP_MLNAME_CAST(sipName_GetRightLocation), (PyCFunction)meth_wxFilterFSHandler_GetRightLocation, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxFilterFSHandler_GetRightLocation)},
    {SIP_MLNAME_CAST(sipName_OpenFile), meth_wxFilterFSHandler_OpenFile, METH_VARARGS, NULL}
};

PyDoc_STRVAR(doc_wxFilterFSHandler, "FilterFSHandler()\n"
    "\n"
    "Filter file system handler.");


sipClassTypeDef sipTypeDef__core_wxFilterFSHandler = {
    {
        -1,
        0,
        0,
        SIP_TYPE_SCC|SIP_TYPE_CLASS,
        sipNameNr_wxFilterFSHandler,
        {0}
    },
    {
        sipNameNr_FilterFSHandler,
        {0, 0, 1},
        6, methods_wxFilterFSHandler,
        0, 0,
        0, 0,
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    },
    doc_wxFilterFSHandler,
    -1,
    -1,
    supers_wxFilterFSHandler,
    0,
    init_type_wxFilterFSHandler,
    0,
    0,
#if PY_MAJOR_VERSION >= 3
    0,
    0,
#else
    0,
    0,
    0,
    0,
#endif
    dealloc_wxFilterFSHandler,
    0,
    0,
    0,
    release_wxFilterFSHandler,
    cast_wxFilterFSHandler,
    0,
    0,
    0,
    0,
    0,
    0
};
