/*
 * Interface wrapper code.
 *
 * Generated by SIP 4.16.7
 *
 *     Copyright: (c) 2013 by Total Control Software
 *     License:   wxWindows License
 */

#include "sipAPI_core.h"

        #include <wx/graphics.h>

        #include <wx/image.h>
        #include <wx/graphics.h>
        #include <wx/object.h>
        #include <wx/object.h>


PyDoc_STRVAR(doc_wxGraphicsBitmap_ConvertToImage, "ConvertToImage() -> Image\n"
    "\n"
    "Return the contents of this bitmap as wxImage.");

extern "C" {static PyObject *meth_wxGraphicsBitmap_ConvertToImage(PyObject *, PyObject *);}
static PyObject *meth_wxGraphicsBitmap_ConvertToImage(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const wxGraphicsBitmap *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxGraphicsBitmap, &sipCpp))
        {
            wxImage*sipRes;

            PyErr_Clear();

            sipRes = new wxImage(sipCpp->ConvertToImage());

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromNewType(sipRes,sipType_wxImage,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_GraphicsBitmap, sipName_ConvertToImage, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxGraphicsBitmap_GetNativeBitmap, "GetNativeBitmap() -> void\n"
    "\n"
    "Return the pointer to the native bitmap data.");

extern "C" {static PyObject *meth_wxGraphicsBitmap_GetNativeBitmap(PyObject *, PyObject *);}
static PyObject *meth_wxGraphicsBitmap_GetNativeBitmap(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const wxGraphicsBitmap *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxGraphicsBitmap, &sipCpp))
        {
            void*sipRes;

            PyErr_Clear();

            sipRes = sipCpp->GetNativeBitmap();

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromVoidPtr(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_GraphicsBitmap, sipName_GetNativeBitmap, NULL);

    return NULL;
}


/* Cast a pointer to a type somewhere in its superclass hierarchy. */
extern "C" {static void *cast_wxGraphicsBitmap(void *, const sipTypeDef *);}
static void *cast_wxGraphicsBitmap(void *ptr, const sipTypeDef *targetType)
{
    void *res;

    if (targetType == sipType_wxGraphicsBitmap)
        return ptr;

    if ((res = ((const sipClassTypeDef *)sipType_wxGraphicsObject)->ctd_cast((wxGraphicsObject *)(wxGraphicsBitmap *)ptr,targetType)) != NULL)
        return res;

    return NULL;
}


/* Call the instance's destructor. */
extern "C" {static void release_wxGraphicsBitmap(void *, int);}
static void release_wxGraphicsBitmap(void *sipCppV,int)
{
    delete reinterpret_cast<wxGraphicsBitmap *>(sipCppV);
}


extern "C" {static void assign_wxGraphicsBitmap(void *, SIP_SSIZE_T, const void *);}
static void assign_wxGraphicsBitmap(void *sipDst, SIP_SSIZE_T sipDstIdx, const void *sipSrc)
{
    reinterpret_cast<wxGraphicsBitmap *>(sipDst)[sipDstIdx] = *reinterpret_cast<const wxGraphicsBitmap *>(sipSrc);
}


extern "C" {static void *array_wxGraphicsBitmap(SIP_SSIZE_T);}
static void *array_wxGraphicsBitmap(SIP_SSIZE_T sipNrElem)
{
    return new wxGraphicsBitmap[sipNrElem];
}


extern "C" {static void *copy_wxGraphicsBitmap(const void *, SIP_SSIZE_T);}
static void *copy_wxGraphicsBitmap(const void *sipSrc, SIP_SSIZE_T sipSrcIdx)
{
    return new wxGraphicsBitmap(reinterpret_cast<const wxGraphicsBitmap *>(sipSrc)[sipSrcIdx]);
}


extern "C" {static void dealloc_wxGraphicsBitmap(sipSimpleWrapper *);}
static void dealloc_wxGraphicsBitmap(sipSimpleWrapper *sipSelf)
{
    if (sipIsPyOwned(sipSelf))
    {
        release_wxGraphicsBitmap(sipGetAddress(sipSelf),0);
    }
}


extern "C" {static void *init_type_wxGraphicsBitmap(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_type_wxGraphicsBitmap(sipSimpleWrapper *, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
    wxGraphicsBitmap *sipCpp = 0;

    {
        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, ""))
        {
            PyErr_Clear();

            sipCpp = new wxGraphicsBitmap();

            if (PyErr_Occurred())
            {
                delete sipCpp;
                return NULL;
            }

            return sipCpp;
        }
    }

    {
        const wxGraphicsBitmap* a0;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, "J9", sipType_wxGraphicsBitmap, &a0))
        {
            sipCpp = new wxGraphicsBitmap(*a0);

            return sipCpp;
        }
    }

    return NULL;
}


/* Define this type's super-types. */
static sipEncodedTypeDef supers_wxGraphicsBitmap[] = {{214, 255, 1}};


static PyMethodDef methods_wxGraphicsBitmap[] = {
    {SIP_MLNAME_CAST(sipName_ConvertToImage), meth_wxGraphicsBitmap_ConvertToImage, METH_VARARGS, SIP_MLDOC_CAST(doc_wxGraphicsBitmap_ConvertToImage)},
    {SIP_MLNAME_CAST(sipName_GetNativeBitmap), meth_wxGraphicsBitmap_GetNativeBitmap, METH_VARARGS, SIP_MLDOC_CAST(doc_wxGraphicsBitmap_GetNativeBitmap)}
};

sipVariableDef variables_wxGraphicsBitmap[] = {
    {PropertyVariable, sipName_NativeBitmap, &methods_wxGraphicsBitmap[1], NULL, NULL, NULL},
};

PyDoc_STRVAR(doc_wxGraphicsBitmap, "GraphicsBitmap()\n"
    "\n"
    "Represents a bitmap.");


sipClassTypeDef sipTypeDef__core_wxGraphicsBitmap = {
    {
        -1,
        0,
        0,
        SIP_TYPE_SCC|SIP_TYPE_CLASS,
        sipNameNr_wxGraphicsBitmap,
        {0}
    },
    {
        sipNameNr_GraphicsBitmap,
        {0, 0, 1},
        2, methods_wxGraphicsBitmap,
        0, 0,
        1, variables_wxGraphicsBitmap,
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    },
    doc_wxGraphicsBitmap,
    -1,
    -1,
    supers_wxGraphicsBitmap,
    0,
    init_type_wxGraphicsBitmap,
    0,
    0,
#if PY_MAJOR_VERSION >= 3
    0,
    0,
#else
    0,
    0,
    0,
    0,
#endif
    dealloc_wxGraphicsBitmap,
    assign_wxGraphicsBitmap,
    array_wxGraphicsBitmap,
    copy_wxGraphicsBitmap,
    release_wxGraphicsBitmap,
    cast_wxGraphicsBitmap,
    0,
    0,
    0,
    0,
    0,
    0
};
