/*
 * Interface wrapper code.
 *
 * Generated by SIP 4.16.7
 *
 *     Copyright: (c) 2013 by Total Control Software
 *     License:   wxWindows License
 */

#include "sipAPI_core.h"

        #include <wx/fs_mem.h>

        #include <wx/filesys.h>
        #include <wx/filesys.h>
    #include <wxpy_api.h>
        #include <wx/image.h>
        #include <wx/bitmap.h>
        #include <wx/object.h>
        #include <wx/object.h>


class sipwxMemoryFSHandler : public wxMemoryFSHandler
{
public:
    sipwxMemoryFSHandler();
    virtual ~sipwxMemoryFSHandler();

    /*
     * There is a public method for every protected method visible from
     * this class.
     */
    static wxString sipProtect_GetAnchor(const wxString&);
    static wxString sipProtect_GetLeftLocation(const wxString&);
    static wxString sipProtect_GetProtocol(const wxString&);
    static wxString sipProtect_GetRightLocation(const wxString&);

    /*
     * There is a protected method for every virtual method visible from
     * this class.
     */
protected:
    wxString FindNext();
    wxString FindFirst(const wxString&,int);

public:
    sipSimpleWrapper *sipPySelf;

private:
    sipwxMemoryFSHandler(const sipwxMemoryFSHandler &);
    sipwxMemoryFSHandler &operator = (const sipwxMemoryFSHandler &);

    char sipPyMethods[2];
};

sipwxMemoryFSHandler::sipwxMemoryFSHandler(): wxMemoryFSHandler(), sipPySelf(0)
{
    memset(sipPyMethods, 0, sizeof (sipPyMethods));
}

sipwxMemoryFSHandler::~sipwxMemoryFSHandler()
{
    sipCommonDtor(sipPySelf);
}

wxString sipwxMemoryFSHandler::FindNext()
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,&sipPyMethods[0],sipPySelf,NULL,sipName_FindNext);

    if (!sipMeth)
        return wxMemoryFSHandler::FindNext();

    extern wxString sipVH__core_3(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *);

    return sipVH__core_3(sipGILState, 0, sipPySelf, sipMeth);
}

wxString sipwxMemoryFSHandler::FindFirst(const wxString& wildcard,int flags)
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,&sipPyMethods[1],sipPySelf,NULL,sipName_FindFirst);

    if (!sipMeth)
        return wxMemoryFSHandler::FindFirst(wildcard,flags);

    extern wxString sipVH__core_210(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *, const wxString&,int);

    return sipVH__core_210(sipGILState, 0, sipPySelf, sipMeth, wildcard, flags);
}

wxString sipwxMemoryFSHandler::sipProtect_GetAnchor(const wxString& location)
{
    return wxFileSystemHandler::GetAnchor(location);
}

wxString sipwxMemoryFSHandler::sipProtect_GetLeftLocation(const wxString& location)
{
    return wxFileSystemHandler::GetLeftLocation(location);
}

wxString sipwxMemoryFSHandler::sipProtect_GetProtocol(const wxString& location)
{
    return wxFileSystemHandler::GetProtocol(location);
}

wxString sipwxMemoryFSHandler::sipProtect_GetRightLocation(const wxString& location)
{
    return wxFileSystemHandler::GetRightLocation(location);
}


PyDoc_STRVAR(doc_wxMemoryFSHandler_GetAnchor, "GetAnchor(location) -> String\n"
    "\n"
    "Returns the anchor if present in the location.");

extern "C" {static PyObject *meth_wxMemoryFSHandler_GetAnchor(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxMemoryFSHandler_GetAnchor(PyObject *, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxString* location;
        int locationState = 0;

        static const char *sipKwdList[] = {
            sipName_location,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "J1", sipType_wxString,&location, &locationState))
        {
            wxString*sipRes;

            PyErr_Clear();

            sipRes = new wxString(sipwxMemoryFSHandler::sipProtect_GetAnchor(*location));
            sipReleaseType(const_cast<wxString *>(location),sipType_wxString,locationState);

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromNewType(sipRes,sipType_wxString,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_MemoryFSHandler, sipName_GetAnchor, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxMemoryFSHandler_GetLeftLocation, "GetLeftLocation(location) -> String\n"
    "\n"
    "Returns the left location string extracted from location.");

extern "C" {static PyObject *meth_wxMemoryFSHandler_GetLeftLocation(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxMemoryFSHandler_GetLeftLocation(PyObject *, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxString* location;
        int locationState = 0;

        static const char *sipKwdList[] = {
            sipName_location,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "J1", sipType_wxString,&location, &locationState))
        {
            wxString*sipRes;

            PyErr_Clear();

            sipRes = new wxString(sipwxMemoryFSHandler::sipProtect_GetLeftLocation(*location));
            sipReleaseType(const_cast<wxString *>(location),sipType_wxString,locationState);

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromNewType(sipRes,sipType_wxString,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_MemoryFSHandler, sipName_GetLeftLocation, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxMemoryFSHandler_GetProtocol, "GetProtocol(location) -> String\n"
    "\n"
    "Returns the protocol string extracted from location.");

extern "C" {static PyObject *meth_wxMemoryFSHandler_GetProtocol(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxMemoryFSHandler_GetProtocol(PyObject *, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxString* location;
        int locationState = 0;

        static const char *sipKwdList[] = {
            sipName_location,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "J1", sipType_wxString,&location, &locationState))
        {
            wxString*sipRes;

            PyErr_Clear();

            sipRes = new wxString(sipwxMemoryFSHandler::sipProtect_GetProtocol(*location));
            sipReleaseType(const_cast<wxString *>(location),sipType_wxString,locationState);

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromNewType(sipRes,sipType_wxString,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_MemoryFSHandler, sipName_GetProtocol, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxMemoryFSHandler_GetRightLocation, "GetRightLocation(location) -> String\n"
    "\n"
    "Returns the right location string extracted from location.");

extern "C" {static PyObject *meth_wxMemoryFSHandler_GetRightLocation(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxMemoryFSHandler_GetRightLocation(PyObject *, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxString* location;
        int locationState = 0;

        static const char *sipKwdList[] = {
            sipName_location,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "J1", sipType_wxString,&location, &locationState))
        {
            wxString*sipRes;

            PyErr_Clear();

            sipRes = new wxString(sipwxMemoryFSHandler::sipProtect_GetRightLocation(*location));
            sipReleaseType(const_cast<wxString *>(location),sipType_wxString,locationState);

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromNewType(sipRes,sipType_wxString,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_MemoryFSHandler, sipName_GetRightLocation, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxMemoryFSHandler_AddFile, "AddFile(filename, image, type)\n"
    "AddFile(filename, bitmap, type)\n"
    "\n"
    "Adds a file to the list of the files stored in memory.");

extern "C" {static PyObject *meth_wxMemoryFSHandler_AddFile(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxMemoryFSHandler_AddFile(PyObject *, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxString* filename;
        int filenameState = 0;
        wxImage* image;
        wxBitmapType type;

        static const char *sipKwdList[] = {
            sipName_filename,
            sipName_image,
            sipName_type,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "J1J9E", sipType_wxString,&filename, &filenameState, sipType_wxImage, &image, sipType_wxBitmapType, &type))
        {
            PyErr_Clear();

            wxMemoryFSHandler::AddFile(*filename,*image,type);
            sipReleaseType(const_cast<wxString *>(filename),sipType_wxString,filenameState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    {
        const wxString* filename;
        int filenameState = 0;
        const wxBitmap* bitmap;
        wxBitmapType type;

        static const char *sipKwdList[] = {
            sipName_filename,
            sipName_bitmap,
            sipName_type,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "J1J9E", sipType_wxString,&filename, &filenameState, sipType_wxBitmap, &bitmap, sipType_wxBitmapType, &type))
        {
            PyErr_Clear();

            wxMemoryFSHandler::AddFile(*filename,*bitmap,type);
            sipReleaseType(const_cast<wxString *>(filename),sipType_wxString,filenameState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_MemoryFSHandler, sipName_AddFile, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxMemoryFSHandler_AddFileWithMimeType, "AddFileWithMimeType(filename, textdata, mimetype)\n"
    "AddFileWithMimeType(filename, binarydata, size, mimetype)\n"
    "\n"
    "Like AddFile(), but lets you explicitly specify added file's MIME\n"
    "type.");

extern "C" {static PyObject *meth_wxMemoryFSHandler_AddFileWithMimeType(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxMemoryFSHandler_AddFileWithMimeType(PyObject *, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxString* filename;
        int filenameState = 0;
        const wxString* textdata;
        int textdataState = 0;
        const wxString* mimetype;
        int mimetypeState = 0;

        static const char *sipKwdList[] = {
            sipName_filename,
            sipName_textdata,
            sipName_mimetype,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "J1J1J1", sipType_wxString,&filename, &filenameState, sipType_wxString,&textdata, &textdataState, sipType_wxString,&mimetype, &mimetypeState))
        {
            PyErr_Clear();

            wxMemoryFSHandler::AddFileWithMimeType(*filename,*textdata,*mimetype);
            sipReleaseType(const_cast<wxString *>(filename),sipType_wxString,filenameState);
            sipReleaseType(const_cast<wxString *>(textdata),sipType_wxString,textdataState);
            sipReleaseType(const_cast<wxString *>(mimetype),sipType_wxString,mimetypeState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    {
        const wxString* filename;
        int filenameState = 0;
        const void* binarydata;
        size_t* size;
        int sizeState = 0;
        const wxString* mimetype;
        int mimetypeState = 0;

        static const char *sipKwdList[] = {
            sipName_filename,
            sipName_binarydata,
            sipName_size,
            sipName_mimetype,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "J1vJ1J1", sipType_wxString,&filename, &filenameState, &binarydata, sipType_size_t,&size, &sizeState, sipType_wxString,&mimetype, &mimetypeState))
        {
            PyErr_Clear();

            wxMemoryFSHandler::AddFileWithMimeType(*filename,binarydata,*size,*mimetype);
            sipReleaseType(const_cast<wxString *>(filename),sipType_wxString,filenameState);
            sipReleaseType(size,sipType_size_t,sizeState);
            sipReleaseType(const_cast<wxString *>(mimetype),sipType_wxString,mimetypeState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_MemoryFSHandler, sipName_AddFileWithMimeType, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxMemoryFSHandler_RemoveFile, "RemoveFile(filename)\n"
    "\n"
    "Removes a file from memory FS and frees the occupied memory.");

extern "C" {static PyObject *meth_wxMemoryFSHandler_RemoveFile(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxMemoryFSHandler_RemoveFile(PyObject *, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;

    {
        const wxString* filename;
        int filenameState = 0;

        static const char *sipKwdList[] = {
            sipName_filename,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "J1", sipType_wxString,&filename, &filenameState))
        {
            PyErr_Clear();

            wxMemoryFSHandler::RemoveFile(*filename);
            sipReleaseType(const_cast<wxString *>(filename),sipType_wxString,filenameState);

            if (PyErr_Occurred())
                return 0;

            Py_INCREF(Py_None);
            return Py_None;
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_MemoryFSHandler, sipName_RemoveFile, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_wxMemoryFSHandler_CanOpen(PyObject *, PyObject *);}
static PyObject *meth_wxMemoryFSHandler_CanOpen(PyObject *, PyObject *)
{

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(NULL, sipName_MemoryFSHandler, sipName_CanOpen, NULL);

    return NULL;
}


extern "C" {static PyObject *meth_wxMemoryFSHandler_OpenFile(PyObject *, PyObject *);}
static PyObject *meth_wxMemoryFSHandler_OpenFile(PyObject *, PyObject *)
{

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(NULL, sipName_MemoryFSHandler, sipName_OpenFile, NULL);

    return NULL;
}


/* Cast a pointer to a type somewhere in its superclass hierarchy. */
extern "C" {static void *cast_wxMemoryFSHandler(void *, const sipTypeDef *);}
static void *cast_wxMemoryFSHandler(void *ptr, const sipTypeDef *targetType)
{
    void *res;

    if (targetType == sipType_wxMemoryFSHandler)
        return ptr;

    if ((res = ((const sipClassTypeDef *)sipType_wxFileSystemHandler)->ctd_cast((wxFileSystemHandler *)(wxMemoryFSHandler *)ptr,targetType)) != NULL)
        return res;

    return NULL;
}


/* Call the instance's destructor. */
extern "C" {static void release_wxMemoryFSHandler(void *, int);}
static void release_wxMemoryFSHandler(void *sipCppV,int sipState)
{
    if (sipState & SIP_DERIVED_CLASS)
        delete reinterpret_cast<sipwxMemoryFSHandler *>(sipCppV);
    else
        delete reinterpret_cast<wxMemoryFSHandler *>(sipCppV);
}


extern "C" {static void dealloc_wxMemoryFSHandler(sipSimpleWrapper *);}
static void dealloc_wxMemoryFSHandler(sipSimpleWrapper *sipSelf)
{
    if (sipIsDerived(sipSelf))
        reinterpret_cast<sipwxMemoryFSHandler *>(sipGetAddress(sipSelf))->sipPySelf = NULL;

    if (sipIsPyOwned(sipSelf))
    {
        release_wxMemoryFSHandler(sipGetAddress(sipSelf),sipSelf->flags);
    }
}


extern "C" {static void *init_type_wxMemoryFSHandler(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_type_wxMemoryFSHandler(sipSimpleWrapper *sipSelf, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
    sipwxMemoryFSHandler *sipCpp = 0;

    {
        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, ""))
        {
            PyErr_Clear();

            sipCpp = new sipwxMemoryFSHandler();

            if (PyErr_Occurred())
            {
                delete sipCpp;
                return NULL;
            }

            sipCpp->sipPySelf = sipSelf;

            return sipCpp;
        }
    }

    return NULL;
}


/* Define this type's super-types. */
static sipEncodedTypeDef supers_wxMemoryFSHandler[] = {{159, 255, 1}};


static PyMethodDef methods_wxMemoryFSHandler[] = {
    {SIP_MLNAME_CAST(sipName_AddFile), (PyCFunction)meth_wxMemoryFSHandler_AddFile, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxMemoryFSHandler_AddFile)},
    {SIP_MLNAME_CAST(sipName_AddFileWithMimeType), (PyCFunction)meth_wxMemoryFSHandler_AddFileWithMimeType, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxMemoryFSHandler_AddFileWithMimeType)},
    {SIP_MLNAME_CAST(sipName_CanOpen), meth_wxMemoryFSHandler_CanOpen, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_GetAnchor), (PyCFunction)meth_wxMemoryFSHandler_GetAnchor, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxMemoryFSHandler_GetAnchor)},
    {SIP_MLNAME_CAST(sipName_GetLeftLocation), (PyCFunction)meth_wxMemoryFSHandler_GetLeftLocation, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxMemoryFSHandler_GetLeftLocation)},
    {SIP_MLNAME_CAST(sipName_GetProtocol), (PyCFunction)meth_wxMemoryFSHandler_GetProtocol, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxMemoryFSHandler_GetProtocol)},
    {SIP_MLNAME_CAST(sipName_GetRightLocation), (PyCFunction)meth_wxMemoryFSHandler_GetRightLocation, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxMemoryFSHandler_GetRightLocation)},
    {SIP_MLNAME_CAST(sipName_OpenFile), meth_wxMemoryFSHandler_OpenFile, METH_VARARGS, NULL},
    {SIP_MLNAME_CAST(sipName_RemoveFile), (PyCFunction)meth_wxMemoryFSHandler_RemoveFile, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxMemoryFSHandler_RemoveFile)}
};

PyDoc_STRVAR(doc_wxMemoryFSHandler, "MemoryFSHandler()\n"
    "\n"
    "This wxFileSystem handler can store arbitrary data in memory stream\n"
    "and make them accessible via an URL.");


sipClassTypeDef sipTypeDef__core_wxMemoryFSHandler = {
    {
        -1,
        0,
        0,
        SIP_TYPE_SCC|SIP_TYPE_CLASS,
        sipNameNr_wxMemoryFSHandler,
        {0}
    },
    {
        sipNameNr_MemoryFSHandler,
        {0, 0, 1},
        9, methods_wxMemoryFSHandler,
        0, 0,
        0, 0,
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    },
    doc_wxMemoryFSHandler,
    -1,
    -1,
    supers_wxMemoryFSHandler,
    0,
    init_type_wxMemoryFSHandler,
    0,
    0,
#if PY_MAJOR_VERSION >= 3
    0,
    0,
#else
    0,
    0,
    0,
    0,
#endif
    dealloc_wxMemoryFSHandler,
    0,
    0,
    0,
    release_wxMemoryFSHandler,
    cast_wxMemoryFSHandler,
    0,
    0,
    0,
    0,
    0,
    0
};
