/*
 * Interface wrapper code.
 *
 * Generated by SIP 4.16.7
 *
 *     Copyright: (c) 2013 by Total Control Software
 *     License:   wxWindows License
 */

#include "sipAPI_core.h"

        #include <wx/dcprint.h>

        #include <wx/cmndata.h>
        #include <wx/gdicmn.h>
        #include <wx/bitmap.h>
        #include <wx/gdicmn.h>
        #include <wx/colour.h>
        #include <wx/gdicmn.h>
        #include <wx/dc.h>
        #include <wx/pen.h>
        #include "arrayholder.h"
        #include <wx/brush.h>
        #include <wx/font.h>
        #include <wx/dc.h>
        #include <wx/region.h>
        
        #include <wx/icon.h>
        #include <wx/object.h>
        #include <wx/object.h>


PyDoc_STRVAR(doc_wxPrinterDC_GetPaperRect, "GetPaperRect() -> Rect\n"
    "\n"
    "Return the rectangle in device coordinates that corresponds to the\n"
    "full paper area, including the nonprinting regions of the paper.");

extern "C" {static PyObject *meth_wxPrinterDC_GetPaperRect(PyObject *, PyObject *);}
static PyObject *meth_wxPrinterDC_GetPaperRect(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const wxPrinterDC *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxPrinterDC, &sipCpp))
        {
            wxRect*sipRes;

            PyErr_Clear();

            sipRes = new wxRect(sipCpp->GetPaperRect());

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromNewType(sipRes,sipType_wxRect,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_PrinterDC, sipName_GetPaperRect, NULL);

    return NULL;
}


/* Cast a pointer to a type somewhere in its superclass hierarchy. */
extern "C" {static void *cast_wxPrinterDC(void *, const sipTypeDef *);}
static void *cast_wxPrinterDC(void *ptr, const sipTypeDef *targetType)
{
    void *res;

    if (targetType == sipType_wxPrinterDC)
        return ptr;

    if ((res = ((const sipClassTypeDef *)sipType_wxDC)->ctd_cast((wxDC *)(wxPrinterDC *)ptr,targetType)) != NULL)
        return res;

    return NULL;
}


/* Call the instance's destructor. */
extern "C" {static void release_wxPrinterDC(void *, int);}
static void release_wxPrinterDC(void *sipCppV,int)
{
    delete reinterpret_cast<wxPrinterDC *>(sipCppV);
}


extern "C" {static void dealloc_wxPrinterDC(sipSimpleWrapper *);}
static void dealloc_wxPrinterDC(sipSimpleWrapper *sipSelf)
{
    if (sipIsPyOwned(sipSelf))
    {
        release_wxPrinterDC(sipGetAddress(sipSelf),0);
    }
}


extern "C" {static void *init_type_wxPrinterDC(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_type_wxPrinterDC(sipSimpleWrapper *, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
    wxPrinterDC *sipCpp = 0;

    {
        const wxPrintData* printData;

        static const char *sipKwdList[] = {
            sipName_printData,
        };

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, sipKwdList, sipUnused, "J9", sipType_wxPrintData, &printData))
        {
            PyErr_Clear();

            sipCpp = new wxPrinterDC(*printData);

            if (PyErr_Occurred())
            {
                delete sipCpp;
                return NULL;
            }

            return sipCpp;
        }
    }

    return NULL;
}


/* Define this type's super-types. */
static sipEncodedTypeDef supers_wxPrinterDC[] = {{87, 255, 1}};


static PyMethodDef methods_wxPrinterDC[] = {
    {SIP_MLNAME_CAST(sipName_GetPaperRect), meth_wxPrinterDC_GetPaperRect, METH_VARARGS, SIP_MLDOC_CAST(doc_wxPrinterDC_GetPaperRect)}
};

sipVariableDef variables_wxPrinterDC[] = {
    {PropertyVariable, sipName_PaperRect, &methods_wxPrinterDC[0], NULL, NULL, NULL},
};

PyDoc_STRVAR(doc_wxPrinterDC, "PrinterDC(printData)\n"
    "\n"
    "A printer device context is specific to MSW and Mac, and allows access\n"
    "to any printer with a Windows or Macintosh driver.");


sipClassTypeDef sipTypeDef__core_wxPrinterDC = {
    {
        -1,
        0,
        0,
        SIP_TYPE_SCC|SIP_TYPE_CLASS,
        sipNameNr_wxPrinterDC,
        {0}
    },
    {
        sipNameNr_PrinterDC,
        {0, 0, 1},
        1, methods_wxPrinterDC,
        0, 0,
        1, variables_wxPrinterDC,
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    },
    doc_wxPrinterDC,
    -1,
    -1,
    supers_wxPrinterDC,
    0,
    init_type_wxPrinterDC,
    0,
    0,
#if PY_MAJOR_VERSION >= 3
    0,
    0,
#else
    0,
    0,
    0,
    0,
#endif
    dealloc_wxPrinterDC,
    0,
    0,
    0,
    release_wxPrinterDC,
    cast_wxPrinterDC,
    0,
    0,
    0,
    0,
    0,
    0
};
