/*
 * Interface wrapper code.
 *
 * Generated by SIP 4.16.7
 *
 *     Copyright: (c) 2013 by Total Control Software
 *     License:   wxWindows License
 */

#include "sipAPI_core.h"

        #include <wx/process.h>

        #include <wx/object.h>
        #include <wx/event.h>
        #include <wx/object.h>


PyDoc_STRVAR(doc_wxProcessEvent_GetExitCode, "GetExitCode() -> int\n"
    "\n"
    "Returns the exist status.");

extern "C" {static PyObject *meth_wxProcessEvent_GetExitCode(PyObject *, PyObject *);}
static PyObject *meth_wxProcessEvent_GetExitCode(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        wxProcessEvent *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxProcessEvent, &sipCpp))
        {
            int sipRes;

            PyErr_Clear();

            sipRes = sipCpp->GetExitCode();

            if (PyErr_Occurred())
                return 0;

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ProcessEvent, sipName_GetExitCode, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxProcessEvent_GetPid, "GetPid() -> int\n"
    "\n"
    "Returns the process id.");

extern "C" {static PyObject *meth_wxProcessEvent_GetPid(PyObject *, PyObject *);}
static PyObject *meth_wxProcessEvent_GetPid(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        wxProcessEvent *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxProcessEvent, &sipCpp))
        {
            int sipRes;

            PyErr_Clear();

            sipRes = sipCpp->GetPid();

            if (PyErr_Occurred())
                return 0;

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_ProcessEvent, sipName_GetPid, NULL);

    return NULL;
}


/* Cast a pointer to a type somewhere in its superclass hierarchy. */
extern "C" {static void *cast_wxProcessEvent(void *, const sipTypeDef *);}
static void *cast_wxProcessEvent(void *ptr, const sipTypeDef *targetType)
{
    void *res;

    if (targetType == sipType_wxProcessEvent)
        return ptr;

    if ((res = ((const sipClassTypeDef *)sipType_wxEvent)->ctd_cast((wxEvent *)(wxProcessEvent *)ptr,targetType)) != NULL)
        return res;

    return NULL;
}


/* Call the instance's destructor. */
extern "C" {static void release_wxProcessEvent(void *, int);}
static void release_wxProcessEvent(void *sipCppV,int)
{
    delete reinterpret_cast<wxProcessEvent *>(sipCppV);
}


extern "C" {static void dealloc_wxProcessEvent(sipSimpleWrapper *);}
static void dealloc_wxProcessEvent(sipSimpleWrapper *sipSelf)
{
    if (sipIsPyOwned(sipSelf))
    {
        release_wxProcessEvent(sipGetAddress(sipSelf),0);
    }
}


extern "C" {static void *init_type_wxProcessEvent(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_type_wxProcessEvent(sipSimpleWrapper *, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
    wxProcessEvent *sipCpp = 0;

    {
        int id = 0;
        int pid = 0;
        int exitcode = 0;

        static const char *sipKwdList[] = {
            sipName_id,
            sipName_pid,
            sipName_exitcode,
        };

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, sipKwdList, sipUnused, "|iii", &id, &pid, &exitcode))
        {
            PyErr_Clear();

            sipCpp = new wxProcessEvent(id,pid,exitcode);

            if (PyErr_Occurred())
            {
                delete sipCpp;
                return NULL;
            }

            return sipCpp;
        }
    }

    {
        const wxProcessEvent* a0;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, "J9", sipType_wxProcessEvent, &a0))
        {
            sipCpp = new wxProcessEvent(*a0);

            return sipCpp;
        }
    }

    return NULL;
}


/* Define this type's super-types. */
static sipEncodedTypeDef supers_wxProcessEvent[] = {{134, 255, 1}};


static PyMethodDef methods_wxProcessEvent[] = {
    {SIP_MLNAME_CAST(sipName_GetExitCode), meth_wxProcessEvent_GetExitCode, METH_VARARGS, SIP_MLDOC_CAST(doc_wxProcessEvent_GetExitCode)},
    {SIP_MLNAME_CAST(sipName_GetPid), meth_wxProcessEvent_GetPid, METH_VARARGS, SIP_MLDOC_CAST(doc_wxProcessEvent_GetPid)}
};

sipVariableDef variables_wxProcessEvent[] = {
    {PropertyVariable, sipName_Pid, &methods_wxProcessEvent[1], NULL, NULL, NULL},
    {PropertyVariable, sipName_ExitCode, &methods_wxProcessEvent[0], NULL, NULL, NULL},
};

PyDoc_STRVAR(doc_wxProcessEvent, "ProcessEvent(id=0, pid=0, exitcode=0)\n"
    "\n"
    "A process event is sent to the wxEvtHandler specified to wxProcess\n"
    "when a process is terminated.");


sipClassTypeDef sipTypeDef__core_wxProcessEvent = {
    {
        -1,
        0,
        0,
        SIP_TYPE_ABSTRACT|SIP_TYPE_SCC|SIP_TYPE_CLASS,
        sipNameNr_wxProcessEvent,
        {0}
    },
    {
        sipNameNr_ProcessEvent,
        {0, 0, 1},
        2, methods_wxProcessEvent,
        0, 0,
        2, variables_wxProcessEvent,
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    },
    doc_wxProcessEvent,
    -1,
    -1,
    supers_wxProcessEvent,
    0,
    init_type_wxProcessEvent,
    0,
    0,
#if PY_MAJOR_VERSION >= 3
    0,
    0,
#else
    0,
    0,
    0,
    0,
#endif
    dealloc_wxProcessEvent,
    0,
    0,
    0,
    release_wxProcessEvent,
    cast_wxProcessEvent,
    0,
    0,
    0,
    0,
    0,
    0
};
