/*
 * Interface wrapper code.
 *
 * Generated by SIP 4.16.7
 *
 *     Copyright: (c) 2013 by Total Control Software
 *     License:   wxWindows License
 */

#include "sipAPI_core.h"

        #include <wx/timer.h>

        #include <wx/timer.h>
        #include <wx/object.h>
        #include <wx/event.h>
        #include <wx/object.h>


PyDoc_STRVAR(doc_wxTimerEvent_GetInterval, "GetInterval() -> int\n"
    "\n"
    "Returns the interval of the timer which generated this event.");

extern "C" {static PyObject *meth_wxTimerEvent_GetInterval(PyObject *, PyObject *);}
static PyObject *meth_wxTimerEvent_GetInterval(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const wxTimerEvent *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxTimerEvent, &sipCpp))
        {
            int sipRes;

            PyErr_Clear();

            sipRes = sipCpp->GetInterval();

            if (PyErr_Occurred())
                return 0;

            return SIPLong_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_TimerEvent, sipName_GetInterval, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxTimerEvent_GetTimer, "GetTimer() -> Timer\n"
    "\n"
    "Returns the timer object which generated this event.");

extern "C" {static PyObject *meth_wxTimerEvent_GetTimer(PyObject *, PyObject *);}
static PyObject *meth_wxTimerEvent_GetTimer(PyObject *sipSelf, PyObject *sipArgs)
{
    PyObject *sipParseErr = NULL;

    {
        const wxTimerEvent *sipCpp;

        if (sipParseArgs(&sipParseErr, sipArgs, "B", &sipSelf, sipType_wxTimerEvent, &sipCpp))
        {
            wxTimer*sipRes;

            PyErr_Clear();

            sipRes = &sipCpp->GetTimer();

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromType(sipRes,sipType_wxTimer,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_TimerEvent, sipName_GetTimer, NULL);

    return NULL;
}


/* Cast a pointer to a type somewhere in its superclass hierarchy. */
extern "C" {static void *cast_wxTimerEvent(void *, const sipTypeDef *);}
static void *cast_wxTimerEvent(void *ptr, const sipTypeDef *targetType)
{
    void *res;

    if (targetType == sipType_wxTimerEvent)
        return ptr;

    if ((res = ((const sipClassTypeDef *)sipType_wxEvent)->ctd_cast((wxEvent *)(wxTimerEvent *)ptr,targetType)) != NULL)
        return res;

    return NULL;
}


/* Call the instance's destructor. */
extern "C" {static void release_wxTimerEvent(void *, int);}
static void release_wxTimerEvent(void *sipCppV,int)
{
    delete reinterpret_cast<wxTimerEvent *>(sipCppV);
}


extern "C" {static void dealloc_wxTimerEvent(sipSimpleWrapper *);}
static void dealloc_wxTimerEvent(sipSimpleWrapper *sipSelf)
{
    if (sipIsPyOwned(sipSelf))
    {
        release_wxTimerEvent(sipGetAddress(sipSelf),0);
    }
}


extern "C" {static void *init_type_wxTimerEvent(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_type_wxTimerEvent(sipSimpleWrapper *, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
    wxTimerEvent *sipCpp = 0;

    {
        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, ""))
        {
            PyErr_Clear();

            sipCpp = new wxTimerEvent();

            if (PyErr_Occurred())
            {
                delete sipCpp;
                return NULL;
            }

            return sipCpp;
        }
    }

    {
        wxTimer* timer;

        static const char *sipKwdList[] = {
            sipName_timer,
        };

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, sipKwdList, sipUnused, "J9", sipType_wxTimer, &timer))
        {
            PyErr_Clear();

            sipCpp = new wxTimerEvent(*timer);

            if (PyErr_Occurred())
            {
                delete sipCpp;
                return NULL;
            }

            return sipCpp;
        }
    }

    {
        const wxTimerEvent* a0;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, "J9", sipType_wxTimerEvent, &a0))
        {
            sipCpp = new wxTimerEvent(*a0);

            return sipCpp;
        }
    }

    return NULL;
}


/* Define this type's super-types. */
static sipEncodedTypeDef supers_wxTimerEvent[] = {{134, 255, 1}};


static PyMethodDef methods_wxTimerEvent[] = {
    {SIP_MLNAME_CAST(sipName_GetInterval), meth_wxTimerEvent_GetInterval, METH_VARARGS, SIP_MLDOC_CAST(doc_wxTimerEvent_GetInterval)},
    {SIP_MLNAME_CAST(sipName_GetTimer), meth_wxTimerEvent_GetTimer, METH_VARARGS, SIP_MLDOC_CAST(doc_wxTimerEvent_GetTimer)}
};

sipVariableDef variables_wxTimerEvent[] = {
    {PropertyVariable, sipName_Timer, &methods_wxTimerEvent[1], NULL, NULL, NULL},
    {PropertyVariable, sipName_Interval, &methods_wxTimerEvent[0], NULL, NULL, NULL},
};

PyDoc_STRVAR(doc_wxTimerEvent, "TimerEvent()\n"
    "TimerEvent(timer)\n"
    "\n"
    "wxTimerEvent object is passed to the event handler of timer events\n"
    "(see wxTimer::SetOwner).");


sipClassTypeDef sipTypeDef__core_wxTimerEvent = {
    {
        -1,
        0,
        0,
        SIP_TYPE_ABSTRACT|SIP_TYPE_SCC|SIP_TYPE_CLASS,
        sipNameNr_wxTimerEvent,
        {0}
    },
    {
        sipNameNr_TimerEvent,
        {0, 0, 1},
        2, methods_wxTimerEvent,
        0, 0,
        2, variables_wxTimerEvent,
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    },
    doc_wxTimerEvent,
    -1,
    -1,
    supers_wxTimerEvent,
    0,
    init_type_wxTimerEvent,
    0,
    0,
#if PY_MAJOR_VERSION >= 3
    0,
    0,
#else
    0,
    0,
    0,
    0,
#endif
    dealloc_wxTimerEvent,
    0,
    0,
    0,
    release_wxTimerEvent,
    cast_wxTimerEvent,
    0,
    0,
    0,
    0,
    0,
    0
};
