/*
 * Interface wrapper code.
 *
 * Generated by SIP 4.16.7
 *
 *     Copyright: (c) 2013 by Total Control Software
 *     License:   wxWindows License
 */

#include "sipAPI_core.h"

        #include <wx/utils.h>

        #include <wx/window.h>


/* Cast a pointer to a type somewhere in its superclass hierarchy. */
extern "C" {static void *cast_wxWindowDisabler(void *, const sipTypeDef *);}
static void *cast_wxWindowDisabler(void *ptr, const sipTypeDef *targetType)
{
    if (targetType == sipType_wxWindowDisabler)
        return ptr;

    return NULL;
}


/* Call the instance's destructor. */
extern "C" {static void release_wxWindowDisabler(void *, int);}
static void release_wxWindowDisabler(void *sipCppV,int)
{
    delete reinterpret_cast<wxWindowDisabler *>(sipCppV);
}


extern "C" {static void dealloc_wxWindowDisabler(sipSimpleWrapper *);}
static void dealloc_wxWindowDisabler(sipSimpleWrapper *sipSelf)
{
    if (sipIsPyOwned(sipSelf))
    {
        release_wxWindowDisabler(sipGetAddress(sipSelf),0);
    }
}


extern "C" {static void *init_type_wxWindowDisabler(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_type_wxWindowDisabler(sipSimpleWrapper *, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
    wxWindowDisabler *sipCpp = 0;

    {
        bool disable = 1;

        static const char *sipKwdList[] = {
            sipName_disable,
        };

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, sipKwdList, sipUnused, "|b", &disable))
        {
            PyErr_Clear();

            sipCpp = new wxWindowDisabler(disable);

            if (PyErr_Occurred())
            {
                delete sipCpp;
                return NULL;
            }

            return sipCpp;
        }
    }

    {
        wxWindow* winToSkip;

        static const char *sipKwdList[] = {
            sipName_winToSkip,
        };

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, sipKwdList, sipUnused, "J8", sipType_wxWindow, &winToSkip))
        {
            PyErr_Clear();

            sipCpp = new wxWindowDisabler(winToSkip);

            if (PyErr_Occurred())
            {
                delete sipCpp;
                return NULL;
            }

            return sipCpp;
        }
    }

    return NULL;
}

PyDoc_STRVAR(doc_wxWindowDisabler, "WindowDisabler(disable=True)\n"
    "WindowDisabler(winToSkip)\n"
    "\n"
    "This class disables all windows of the application (may be with the\n"
    "exception of one of them) in its constructor and enables them back in\n"
    "its destructor.");


sipClassTypeDef sipTypeDef__core_wxWindowDisabler = {
    {
        -1,
        0,
        0,
        SIP_TYPE_CLASS,
        sipNameNr_wxWindowDisabler,
        {0}
    },
    {
        sipNameNr_WindowDisabler,
        {0, 0, 1},
        0, 0,
        0, 0,
        0, 0,
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    },
    doc_wxWindowDisabler,
    -1,
    -1,
    0,
    0,
    init_type_wxWindowDisabler,
    0,
    0,
#if PY_MAJOR_VERSION >= 3
    0,
    0,
#else
    0,
    0,
    0,
    0,
#endif
    dealloc_wxWindowDisabler,
    0,
    0,
    0,
    release_wxWindowDisabler,
    cast_wxWindowDisabler,
    0,
    0,
    0,
    0,
    0,
    0
};
