/*
 * Interface wrapper code.
 *
 * Generated by SIP 4.16.7
 *
 *     Copyright: (c) 2013 by Total Control Software
 *     License:   wxWindows License
 */

#include "sipAPI_html2.h"

        #include <wx/webviewarchivehandler.h>

        #include <wx/filesys.h>


class sipwxWebViewArchiveHandler : public wxWebViewArchiveHandler
{
public:
    sipwxWebViewArchiveHandler(const wxString&);
    sipwxWebViewArchiveHandler(const wxWebViewArchiveHandler&);
    virtual ~sipwxWebViewArchiveHandler();

    /*
     * There is a protected method for every virtual method visible from
     * this class.
     */
protected:
    wxString GetName() const;
    wxFSFile* GetFile(const wxString&);

public:
    sipSimpleWrapper *sipPySelf;

private:
    sipwxWebViewArchiveHandler(const sipwxWebViewArchiveHandler &);
    sipwxWebViewArchiveHandler &operator = (const sipwxWebViewArchiveHandler &);

    char sipPyMethods[2];
};

sipwxWebViewArchiveHandler::sipwxWebViewArchiveHandler(const wxString& scheme): wxWebViewArchiveHandler(scheme), sipPySelf(0)
{
    memset(sipPyMethods, 0, sizeof (sipPyMethods));
}

sipwxWebViewArchiveHandler::sipwxWebViewArchiveHandler(const wxWebViewArchiveHandler& a0): wxWebViewArchiveHandler(a0), sipPySelf(0)
{
    memset(sipPyMethods, 0, sizeof (sipPyMethods));
}

sipwxWebViewArchiveHandler::~sipwxWebViewArchiveHandler()
{
    sipCommonDtor(sipPySelf);
}

wxString sipwxWebViewArchiveHandler::GetName() const
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,const_cast<char *>(&sipPyMethods[0]),sipPySelf,NULL,sipName_GetName);

    if (!sipMeth)
        return wxWebViewArchiveHandler::GetName();

    typedef wxString (*sipVH__core_3)(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *);

    return ((sipVH__core_3)(sipModuleAPI__html2__core->em_virthandlers[3]))(sipGILState, 0, sipPySelf, sipMeth);
}

wxFSFile* sipwxWebViewArchiveHandler::GetFile(const wxString& uri)
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,&sipPyMethods[1],sipPySelf,NULL,sipName_GetFile);

    if (!sipMeth)
        return wxWebViewArchiveHandler::GetFile(uri);

    extern wxFSFile* sipVH__html2_2(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *, const wxString&);

    return sipVH__html2_2(sipGILState, 0, sipPySelf, sipMeth, uri);
}


PyDoc_STRVAR(doc_wxWebViewArchiveHandler_GetFile, "GetFile(uri) -> wx.FSFile");

extern "C" {static PyObject *meth_wxWebViewArchiveHandler_GetFile(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxWebViewArchiveHandler_GetFile(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;
    bool sipSelfWasArg = (!sipSelf || sipIsDerived((sipSimpleWrapper *)sipSelf));

    {
        const wxString* uri;
        int uriState = 0;
        wxWebViewArchiveHandler *sipCpp;

        static const char *sipKwdList[] = {
            sipName_uri,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "BJ1", &sipSelf, sipType_wxWebViewArchiveHandler, &sipCpp, sipType_wxString,&uri, &uriState))
        {
            wxFSFile*sipRes;

            PyErr_Clear();

            sipRes = (sipSelfWasArg ? sipCpp->wxWebViewArchiveHandler::GetFile(*uri) : sipCpp->GetFile(*uri));
            sipReleaseType(const_cast<wxString *>(uri),sipType_wxString,uriState);

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromType(sipRes,sipType_wxFSFile,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_WebViewArchiveHandler, sipName_GetFile, NULL);

    return NULL;
}


/* Cast a pointer to a type somewhere in its superclass hierarchy. */
extern "C" {static void *cast_wxWebViewArchiveHandler(void *, const sipTypeDef *);}
static void *cast_wxWebViewArchiveHandler(void *ptr, const sipTypeDef *targetType)
{
    void *res;

    if (targetType == sipType_wxWebViewArchiveHandler)
        return ptr;

    if ((res = ((const sipClassTypeDef *)sipType_wxWebViewHandler)->ctd_cast((wxWebViewHandler *)(wxWebViewArchiveHandler *)ptr,targetType)) != NULL)
        return res;

    return NULL;
}


/* Call the instance's destructor. */
extern "C" {static void release_wxWebViewArchiveHandler(void *, int);}
static void release_wxWebViewArchiveHandler(void *sipCppV,int sipState)
{
    if (sipState & SIP_DERIVED_CLASS)
        delete reinterpret_cast<sipwxWebViewArchiveHandler *>(sipCppV);
    else
        delete reinterpret_cast<wxWebViewArchiveHandler *>(sipCppV);
}


extern "C" {static void dealloc_wxWebViewArchiveHandler(sipSimpleWrapper *);}
static void dealloc_wxWebViewArchiveHandler(sipSimpleWrapper *sipSelf)
{
    if (sipIsDerived(sipSelf))
        reinterpret_cast<sipwxWebViewArchiveHandler *>(sipGetAddress(sipSelf))->sipPySelf = NULL;

    if (sipIsPyOwned(sipSelf))
    {
        release_wxWebViewArchiveHandler(sipGetAddress(sipSelf),sipSelf->flags);
    }
}


extern "C" {static void *init_type_wxWebViewArchiveHandler(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_type_wxWebViewArchiveHandler(sipSimpleWrapper *sipSelf, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
    sipwxWebViewArchiveHandler *sipCpp = 0;

    {
        const wxString* scheme;
        int schemeState = 0;

        static const char *sipKwdList[] = {
            sipName_scheme,
        };

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, sipKwdList, sipUnused, "J1", sipType_wxString,&scheme, &schemeState))
        {
            PyErr_Clear();

            sipCpp = new sipwxWebViewArchiveHandler(*scheme);
            sipReleaseType(const_cast<wxString *>(scheme),sipType_wxString,schemeState);

            if (PyErr_Occurred())
            {
                delete sipCpp;
                return NULL;
            }

            sipCpp->sipPySelf = sipSelf;

            return sipCpp;
        }
    }

    {
        const wxWebViewArchiveHandler* a0;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, "J9", sipType_wxWebViewArchiveHandler, &a0))
        {
            sipCpp = new sipwxWebViewArchiveHandler(*a0);

            sipCpp->sipPySelf = sipSelf;

            return sipCpp;
        }
    }

    return NULL;
}


/* Define this type's super-types. */
static sipEncodedTypeDef supers_wxWebViewArchiveHandler[] = {{6, 255, 1}};


static PyMethodDef methods_wxWebViewArchiveHandler[] = {
    {SIP_MLNAME_CAST(sipName_GetFile), (PyCFunction)meth_wxWebViewArchiveHandler_GetFile, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxWebViewArchiveHandler_GetFile)}
};

PyDoc_STRVAR(doc_wxWebViewArchiveHandler, "WebViewArchiveHandler(scheme)\n"
    "\n"
    "A custom handler for the file scheme which also supports loading from\n"
    "archives.");


sipClassTypeDef sipTypeDef__html2_wxWebViewArchiveHandler = {
    {
        -1,
        0,
        0,
        SIP_TYPE_CLASS,
        sipNameNr_wxWebViewArchiveHandler,
        {0}
    },
    {
        sipNameNr_WebViewArchiveHandler,
        {0, 0, 1},
        1, methods_wxWebViewArchiveHandler,
        0, 0,
        0, 0,
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    },
    doc_wxWebViewArchiveHandler,
    -1,
    -1,
    supers_wxWebViewArchiveHandler,
    0,
    init_type_wxWebViewArchiveHandler,
    0,
    0,
#if PY_MAJOR_VERSION >= 3
    0,
    0,
#else
    0,
    0,
    0,
    0,
#endif
    dealloc_wxWebViewArchiveHandler,
    0,
    0,
    0,
    release_wxWebViewArchiveHandler,
    cast_wxWebViewArchiveHandler,
    0,
    0,
    0,
    0,
    0,
    0
};
