/*
 * Interface wrapper code.
 *
 * Generated by SIP 4.16.7
 *
 *     Copyright: (c) 2013 by Total Control Software
 *     License:   wxWindows License
 */

#include "sipAPI_html.h"

        #include <wx/html/htmlfilt.h>

        #include <wx/filesys.h>
        #include <wx/object.h>
        #include <wx/object.h>


class sipwxHtmlFilter : public wxHtmlFilter
{
public:
    sipwxHtmlFilter();
    sipwxHtmlFilter(const wxHtmlFilter&);
    virtual ~sipwxHtmlFilter();

    /*
     * There is a protected method for every virtual method visible from
     * this class.
     */
protected:
    wxString ReadFile(const wxFSFile&) const;
    bool CanRead(const wxFSFile&) const;

public:
    sipSimpleWrapper *sipPySelf;

private:
    sipwxHtmlFilter(const sipwxHtmlFilter &);
    sipwxHtmlFilter &operator = (const sipwxHtmlFilter &);

    char sipPyMethods[2];
};

sipwxHtmlFilter::sipwxHtmlFilter(): wxHtmlFilter(), sipPySelf(0)
{
    memset(sipPyMethods, 0, sizeof (sipPyMethods));
}

sipwxHtmlFilter::sipwxHtmlFilter(const wxHtmlFilter& a0): wxHtmlFilter(a0), sipPySelf(0)
{
    memset(sipPyMethods, 0, sizeof (sipPyMethods));
}

sipwxHtmlFilter::~sipwxHtmlFilter()
{
    sipCommonDtor(sipPySelf);
}

wxString sipwxHtmlFilter::ReadFile(const wxFSFile& file) const
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,const_cast<char *>(&sipPyMethods[0]),sipPySelf,sipName_HtmlFilter,sipName_ReadFile);

    if (!sipMeth)
        return wxString();

    extern wxString sipVH__html_20(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *, const wxFSFile&);

    return sipVH__html_20(sipGILState, 0, sipPySelf, sipMeth, file);
}

bool sipwxHtmlFilter::CanRead(const wxFSFile& file) const
{
    sip_gilstate_t sipGILState;
    PyObject *sipMeth;

    sipMeth = sipIsPyMethod(&sipGILState,const_cast<char *>(&sipPyMethods[1]),sipPySelf,sipName_HtmlFilter,sipName_CanRead);

    if (!sipMeth)
        return 0;

    extern bool sipVH__html_21(sip_gilstate_t, sipVirtErrorHandlerFunc, sipSimpleWrapper *, PyObject *, const wxFSFile&);

    return sipVH__html_21(sipGILState, 0, sipPySelf, sipMeth, file);
}


PyDoc_STRVAR(doc_wxHtmlFilter_CanRead, "CanRead(file) -> bool\n"
    "\n"
    "Returns true if this filter is capable of reading file file.");

extern "C" {static PyObject *meth_wxHtmlFilter_CanRead(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxHtmlFilter_CanRead(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;
    PyObject *sipOrigSelf = sipSelf;

    {
        const wxFSFile* file;
        const wxHtmlFilter *sipCpp;

        static const char *sipKwdList[] = {
            sipName_file,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "BJ9", &sipSelf, sipType_wxHtmlFilter, &sipCpp, sipType_wxFSFile, &file))
        {
            bool sipRes;

            if (!sipOrigSelf)
            {
                sipAbstractMethod(sipName_HtmlFilter, sipName_CanRead);
                return NULL;
            }

            PyErr_Clear();

            sipRes = sipCpp->CanRead(*file);

            if (PyErr_Occurred())
                return 0;

            return PyBool_FromLong(sipRes);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_HtmlFilter, sipName_CanRead, NULL);

    return NULL;
}


PyDoc_STRVAR(doc_wxHtmlFilter_ReadFile, "ReadFile(file) -> String\n"
    "\n"
    "Reads the file and returns string with HTML document.");

extern "C" {static PyObject *meth_wxHtmlFilter_ReadFile(PyObject *, PyObject *, PyObject *);}
static PyObject *meth_wxHtmlFilter_ReadFile(PyObject *sipSelf, PyObject *sipArgs, PyObject *sipKwds)
{
    PyObject *sipParseErr = NULL;
    PyObject *sipOrigSelf = sipSelf;

    {
        const wxFSFile* file;
        const wxHtmlFilter *sipCpp;

        static const char *sipKwdList[] = {
            sipName_file,
        };

        if (sipParseKwdArgs(&sipParseErr, sipArgs, sipKwds, sipKwdList, NULL, "BJ9", &sipSelf, sipType_wxHtmlFilter, &sipCpp, sipType_wxFSFile, &file))
        {
            wxString*sipRes;

            if (!sipOrigSelf)
            {
                sipAbstractMethod(sipName_HtmlFilter, sipName_ReadFile);
                return NULL;
            }

            PyErr_Clear();

            sipRes = new wxString(sipCpp->ReadFile(*file));

            if (PyErr_Occurred())
                return 0;

            return sipConvertFromNewType(sipRes,sipType_wxString,NULL);
        }
    }

    /* Raise an exception if the arguments couldn't be parsed. */
    sipNoMethod(sipParseErr, sipName_HtmlFilter, sipName_ReadFile, NULL);

    return NULL;
}


/* Cast a pointer to a type somewhere in its superclass hierarchy. */
extern "C" {static void *cast_wxHtmlFilter(void *, const sipTypeDef *);}
static void *cast_wxHtmlFilter(void *ptr, const sipTypeDef *targetType)
{
    void *res;

    if (targetType == sipType_wxHtmlFilter)
        return ptr;

    if ((res = ((const sipClassTypeDef *)sipType_wxObject)->ctd_cast((wxObject *)(wxHtmlFilter *)ptr,targetType)) != NULL)
        return res;

    return NULL;
}


/* Call the instance's destructor. */
extern "C" {static void release_wxHtmlFilter(void *, int);}
static void release_wxHtmlFilter(void *sipCppV,int sipState)
{
    if (sipState & SIP_DERIVED_CLASS)
        delete reinterpret_cast<sipwxHtmlFilter *>(sipCppV);
    else
        delete reinterpret_cast<wxHtmlFilter *>(sipCppV);
}


extern "C" {static void dealloc_wxHtmlFilter(sipSimpleWrapper *);}
static void dealloc_wxHtmlFilter(sipSimpleWrapper *sipSelf)
{
    if (sipIsDerived(sipSelf))
        reinterpret_cast<sipwxHtmlFilter *>(sipGetAddress(sipSelf))->sipPySelf = NULL;

    if (sipIsPyOwned(sipSelf))
    {
        release_wxHtmlFilter(sipGetAddress(sipSelf),sipSelf->flags);
    }
}


extern "C" {static void *init_type_wxHtmlFilter(sipSimpleWrapper *, PyObject *, PyObject *, PyObject **, PyObject **, PyObject **);}
static void *init_type_wxHtmlFilter(sipSimpleWrapper *sipSelf, PyObject *sipArgs, PyObject *sipKwds, PyObject **sipUnused, PyObject **, PyObject **sipParseErr)
{
    sipwxHtmlFilter *sipCpp = 0;

    {
        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, ""))
        {
            PyErr_Clear();

            sipCpp = new sipwxHtmlFilter();

            if (PyErr_Occurred())
            {
                delete sipCpp;
                return NULL;
            }

            sipCpp->sipPySelf = sipSelf;

            return sipCpp;
        }
    }

    {
        const wxHtmlFilter* a0;

        if (sipParseKwdArgs(sipParseErr, sipArgs, sipKwds, NULL, sipUnused, "J9", sipType_wxHtmlFilter, &a0))
        {
            sipCpp = new sipwxHtmlFilter(*a0);

            sipCpp->sipPySelf = sipSelf;

            return sipCpp;
        }
    }

    return NULL;
}


/* Define this type's super-types. */
static sipEncodedTypeDef supers_wxHtmlFilter[] = {{344, 0, 1}};


static PyMethodDef methods_wxHtmlFilter[] = {
    {SIP_MLNAME_CAST(sipName_CanRead), (PyCFunction)meth_wxHtmlFilter_CanRead, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxHtmlFilter_CanRead)},
    {SIP_MLNAME_CAST(sipName_ReadFile), (PyCFunction)meth_wxHtmlFilter_ReadFile, METH_VARARGS|METH_KEYWORDS, SIP_MLDOC_CAST(doc_wxHtmlFilter_ReadFile)}
};

PyDoc_STRVAR(doc_wxHtmlFilter, "HtmlFilter()\n"
    "\n"
    "This class is the parent class of input filters for wxHtmlWindow.");


sipClassTypeDef sipTypeDef__html_wxHtmlFilter = {
    {
        -1,
        0,
        0,
        SIP_TYPE_ABSTRACT|SIP_TYPE_SCC|SIP_TYPE_CLASS,
        sipNameNr_wxHtmlFilter,
        {0}
    },
    {
        sipNameNr_HtmlFilter,
        {0, 0, 1},
        2, methods_wxHtmlFilter,
        0, 0,
        0, 0,
        {0, 0, 0, 0, 0, 0, 0, 0, 0, 0},
    },
    doc_wxHtmlFilter,
    -1,
    -1,
    supers_wxHtmlFilter,
    0,
    init_type_wxHtmlFilter,
    0,
    0,
#if PY_MAJOR_VERSION >= 3
    0,
    0,
#else
    0,
    0,
    0,
    0,
#endif
    dealloc_wxHtmlFilter,
    0,
    0,
    0,
    release_wxHtmlFilter,
    cast_wxHtmlFilter,
    0,
    0,
    0,
    0,
    0,
    0
};
